/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.collaborations.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.ModelElement;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl;
import fr.obeo.acceleo.uml13.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Classifier Role</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getMultiplicity
 * <em>Multiplicity</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getMessage2
 * <em>Message2</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getMessage1
 * <em>Message1</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getAvailableContents
 * <em>Available Contents</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ClassifierRoleImpl extends ClassifierImpl implements ClassifierRole {
	/**
	 * The cached value of the '{@link #getMultiplicity() <em>Multiplicity</em>}
	 * ' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMultiplicity()
	 * @generated
	 * @ordered
	 */
	protected Multiplicity multiplicity = null;

	/**
	 * The cached value of the '{@link #getMessage2() <em>Message2</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMessage2()
	 * @generated
	 * @ordered
	 */
	protected EList message2 = null;

	/**
	 * The cached value of the '{@link #getMessage1() <em>Message1</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMessage1()
	 * @generated
	 * @ordered
	 */
	protected EList message1 = null;

	/**
	 * The cached value of the '{@link #getAvailableContents()
	 * <em>Available Contents</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getAvailableContents()
	 * @generated
	 * @ordered
	 */
	protected EList availableContents = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ClassifierRoleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CollaborationsPackage.eINSTANCE.getClassifierRole();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Multiplicity getMultiplicity() {
		return multiplicity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetMultiplicity(Multiplicity newMultiplicity, NotificationChain msgs) {
		Multiplicity oldMultiplicity = multiplicity;
		multiplicity = newMultiplicity;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, oldMultiplicity, newMultiplicity);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setMultiplicity(Multiplicity newMultiplicity) {
		if (newMultiplicity != multiplicity) {
			NotificationChain msgs = null;
			if (multiplicity != null)
				msgs = ((InternalEObject) multiplicity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, null, msgs);
			if (newMultiplicity != null)
				msgs = ((InternalEObject) newMultiplicity).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, null, msgs);
			msgs = basicSetMultiplicity(newMultiplicity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, newMultiplicity, newMultiplicity));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getMessage2() {
		if (message2 == null) {
			message2 = new EObjectWithInverseResolvingEList(Message.class, this, CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE2, CollaborationsPackage.MESSAGE__SENDER);
		}
		return message2;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getMessage1() {
		if (message1 == null) {
			message1 = new EObjectWithInverseResolvingEList(Message.class, this, CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE1, CollaborationsPackage.MESSAGE__RECEIVER);
		}
		return message1;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAvailableContents() {
		if (availableContents == null) {
			availableContents = new EObjectWithInverseResolvingEList.ManyInverse(ModelElement.class, this, CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS,
					CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE);
		}
		return availableContents;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
				return ((InternalEList) getFeature()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARTICIPANT:
				return ((InternalEList) getParticipant()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
				return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE2:
				return ((InternalEList) getMessage2()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE1:
				return ((InternalEList) getMessage1()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
				return ((InternalEList) getAvailableContents()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
				return eBasicSetContainer(null, CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__BINDING:
				return basicSetBinding(null, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
				return ((InternalEList) getFeature()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARTICIPANT:
				return ((InternalEList) getParticipant()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
				return ((InternalEList) getInstance()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
				return basicSetMultiplicity(null, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE2:
				return ((InternalEList) getMessage2()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE1:
				return ((InternalEList) getMessage1()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
				return ((InternalEList) getAvailableContents()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			return getElementImport();
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			return getName();
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			return getVisibility();
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			return getNamespace();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			return getConstraint();
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			return getPresentation();
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			return getTargetFlow();
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			return getSourceFlow();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case CollaborationsPackage.CLASSIFIER_ROLE__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			return getComment();
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			return getTaggedValue();
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			return getBehavior();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			return getCollaboration();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			return getPartition();
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			return getGeneralization();
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			return getSpecialization();
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			return getOwnedElement();
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			return getFeature();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTICIPANT:
			return getParticipant();
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			return getPowertypeRange();
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			return getInstance();
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			return getCreateAction();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			return getObjectFlowState();
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			return getMultiplicity();
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE2:
			return getMessage2();
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE1:
			return getMessage1();
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			return getAvailableContents();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			setName((String) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__BINDING:
			setBinding((Binding) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			getOwnedElement().clear();
			getOwnedElement().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			getFeature().clear();
			getFeature().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTICIPANT:
			getParticipant().clear();
			getParticipant().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			getPowertypeRange().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			getInstance().clear();
			getInstance().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			getCreateAction().clear();
			getCreateAction().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			getObjectFlowState().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			setMultiplicity((Multiplicity) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE2:
			getMessage2().clear();
			getMessage2().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE1:
			getMessage1().clear();
			getMessage1().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			getAvailableContents().clear();
			getAvailableContents().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			getConstraint().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			getPresentation().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__BINDING:
			setBinding((Binding) null);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			getComment().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			getBehavior().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			getCollaboration().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			getPartition().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			getGeneralization().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			getOwnedElement().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			getFeature().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTICIPANT:
			getParticipant().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			getInstance().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			getCreateAction().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			setMultiplicity((Multiplicity) null);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE2:
			getMessage2().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE1:
			getMessage1().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			getAvailableContents().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			return getNamespace() != null;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__BINDING:
			return binding != null;
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			return comment != null && !comment.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			return stereotype != null;
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			return partition != null && !partition.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			return ownedElement != null && !ownedElement.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			return feature != null && !feature.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTICIPANT:
			return participant != null && !participant.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			return powertypeRange != null && !powertypeRange.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			return instance != null && !instance.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			return createAction != null && !createAction.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			return objectFlowState != null && !objectFlowState.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			return multiplicity != null;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE2:
			return message2 != null && !message2.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE1:
			return message1 != null && !message1.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			return availableContents != null && !availableContents.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // ClassifierRoleImpl
