/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.AttributeLink;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.ComponentInstance;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.LinkEnd;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.Classifier;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Instance</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getClassifier
 * <em>Classifier</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getAttributeLink
 * <em>Attribute Link</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getLinkEnd
 * <em>Link End</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getSlot
 * <em>Slot</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getStimulus1
 * <em>Stimulus1</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getStimulus3
 * <em>Stimulus3</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getComponentInstance
 * <em>Component Instance</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.impl.InstanceImpl#getStimulus2
 * <em>Stimulus2</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class InstanceImpl extends ModelElementImpl implements Instance {
	/**
	 * The cached value of the '{@link #getClassifier() <em>Classifier</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getClassifier()
	 * @generated
	 * @ordered
	 */
	protected EList classifier = null;

	/**
	 * The cached value of the '{@link #getAttributeLink()
	 * <em>Attribute Link</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getAttributeLink()
	 * @generated
	 * @ordered
	 */
	protected EList attributeLink = null;

	/**
	 * The cached value of the '{@link #getLinkEnd() <em>Link End</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getLinkEnd()
	 * @generated
	 * @ordered
	 */
	protected EList linkEnd = null;

	/**
	 * The cached value of the '{@link #getSlot() <em>Slot</em>}' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSlot()
	 * @generated
	 * @ordered
	 */
	protected EList slot = null;

	/**
	 * The cached value of the '{@link #getStimulus1() <em>Stimulus1</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStimulus1()
	 * @generated
	 * @ordered
	 */
	protected EList stimulus1 = null;

	/**
	 * The cached value of the '{@link #getStimulus3() <em>Stimulus3</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStimulus3()
	 * @generated
	 * @ordered
	 */
	protected EList stimulus3 = null;

	/**
	 * The cached value of the '{@link #getComponentInstance()
	 * <em>Component Instance</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getComponentInstance()
	 * @generated
	 * @ordered
	 */
	protected ComponentInstance componentInstance = null;

	/**
	 * The cached value of the '{@link #getStimulus2() <em>Stimulus2</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStimulus2()
	 * @generated
	 * @ordered
	 */
	protected EList stimulus2 = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InstanceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getInstance();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getClassifier() {
		if (classifier == null) {
			classifier = new EObjectWithInverseResolvingEList.ManyInverse(Classifier.class, this, Common_behaviorPackage.INSTANCE__CLASSIFIER, CorePackage.CLASSIFIER__INSTANCE);
		}
		return classifier;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAttributeLink() {
		if (attributeLink == null) {
			attributeLink = new EObjectWithInverseResolvingEList(AttributeLink.class, this, Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK, Common_behaviorPackage.ATTRIBUTE_LINK__VALUE);
		}
		return attributeLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getLinkEnd() {
		if (linkEnd == null) {
			linkEnd = new EObjectWithInverseResolvingEList(LinkEnd.class, this, Common_behaviorPackage.INSTANCE__LINK_END, Common_behaviorPackage.LINK_END__INSTANCE);
		}
		return linkEnd;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSlot() {
		if (slot == null) {
			slot = new EObjectContainmentWithInverseEList(AttributeLink.class, this, Common_behaviorPackage.INSTANCE__SLOT, Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE);
		}
		return slot;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getStimulus1() {
		if (stimulus1 == null) {
			stimulus1 = new EObjectWithInverseResolvingEList.ManyInverse(Stimulus.class, this, Common_behaviorPackage.INSTANCE__STIMULUS1, Common_behaviorPackage.STIMULUS__ARGUMENT);
		}
		return stimulus1;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getStimulus3() {
		if (stimulus3 == null) {
			stimulus3 = new EObjectWithInverseResolvingEList(Stimulus.class, this, Common_behaviorPackage.INSTANCE__STIMULUS3, Common_behaviorPackage.STIMULUS__SENDER);
		}
		return stimulus3;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ComponentInstance getComponentInstance() {
		if (componentInstance != null && componentInstance.eIsProxy()) {
			ComponentInstance oldComponentInstance = componentInstance;
			componentInstance = (ComponentInstance) eResolveProxy((InternalEObject) componentInstance);
			if (componentInstance != oldComponentInstance) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE, oldComponentInstance, componentInstance));
			}
		}
		return componentInstance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ComponentInstance basicGetComponentInstance() {
		return componentInstance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetComponentInstance(ComponentInstance newComponentInstance, NotificationChain msgs) {
		ComponentInstance oldComponentInstance = componentInstance;
		componentInstance = newComponentInstance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE, oldComponentInstance, newComponentInstance);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setComponentInstance(ComponentInstance newComponentInstance) {
		if (newComponentInstance != componentInstance) {
			NotificationChain msgs = null;
			if (componentInstance != null)
				msgs = ((InternalEObject) componentInstance).eInverseRemove(this, Common_behaviorPackage.COMPONENT_INSTANCE__RESIDENT, ComponentInstance.class, msgs);
			if (newComponentInstance != null)
				msgs = ((InternalEObject) newComponentInstance).eInverseAdd(this, Common_behaviorPackage.COMPONENT_INSTANCE__RESIDENT, ComponentInstance.class, msgs);
			msgs = basicSetComponentInstance(newComponentInstance, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE, newComponentInstance, newComponentInstance));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getStimulus2() {
		if (stimulus2 == null) {
			stimulus2 = new EObjectWithInverseResolvingEList(Stimulus.class, this, Common_behaviorPackage.INSTANCE__STIMULUS2, Common_behaviorPackage.STIMULUS__RECEIVER);
		}
		return stimulus2;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.INSTANCE__NAMESPACE, msgs);
			case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER:
				return ((InternalEList) getClassifier()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
				return ((InternalEList) getAttributeLink()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__LINK_END:
				return ((InternalEList) getLinkEnd()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SLOT:
				return ((InternalEList) getSlot()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS1:
				return ((InternalEList) getStimulus1()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS3:
				return ((InternalEList) getStimulus3()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
				if (componentInstance != null)
					msgs = ((InternalEObject) componentInstance).eInverseRemove(this, Common_behaviorPackage.COMPONENT_INSTANCE__RESIDENT, ComponentInstance.class, msgs);
				return basicSetComponentInstance((ComponentInstance) otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS2:
				return ((InternalEList) getStimulus2()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.INSTANCE__NAMESPACE, msgs);
			case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__BINDING:
				return basicSetBinding(null, msgs);
			case Common_behaviorPackage.INSTANCE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER:
				return ((InternalEList) getClassifier()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
				return ((InternalEList) getAttributeLink()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__LINK_END:
				return ((InternalEList) getLinkEnd()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SLOT:
				return ((InternalEList) getSlot()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS1:
				return ((InternalEList) getStimulus1()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS3:
				return ((InternalEList) getStimulus3()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
				return basicSetComponentInstance(null, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS2:
				return ((InternalEList) getStimulus2()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.INSTANCE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.INSTANCE__NAME:
			return getName();
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case Common_behaviorPackage.INSTANCE__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case Common_behaviorPackage.INSTANCE__COMMENT:
			return getComment();
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.INSTANCE__PARTITION:
			return getPartition();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			return getClassifier();
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			return getAttributeLink();
		case Common_behaviorPackage.INSTANCE__LINK_END:
			return getLinkEnd();
		case Common_behaviorPackage.INSTANCE__SLOT:
			return getSlot();
		case Common_behaviorPackage.INSTANCE__STIMULUS1:
			return getStimulus1();
		case Common_behaviorPackage.INSTANCE__STIMULUS3:
			return getStimulus3();
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			if (resolve)
				return getComponentInstance();
			return basicGetComponentInstance();
		case Common_behaviorPackage.INSTANCE__STIMULUS2:
			return getStimulus2();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__BINDING:
			setBinding((Binding) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			getClassifier().clear();
			getClassifier().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			getAttributeLink().clear();
			getAttributeLink().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__LINK_END:
			getLinkEnd().clear();
			getLinkEnd().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__SLOT:
			getSlot().clear();
			getSlot().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS1:
			getStimulus1().clear();
			getStimulus1().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS3:
			getStimulus3().clear();
			getStimulus3().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			setComponentInstance((ComponentInstance) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS2:
			getStimulus2().clear();
			getStimulus2().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.INSTANCE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case Common_behaviorPackage.INSTANCE__BINDING:
			setBinding((Binding) null);
			return;
		case Common_behaviorPackage.INSTANCE__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.INSTANCE__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			getClassifier().clear();
			return;
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			getAttributeLink().clear();
			return;
		case Common_behaviorPackage.INSTANCE__LINK_END:
			getLinkEnd().clear();
			return;
		case Common_behaviorPackage.INSTANCE__SLOT:
			getSlot().clear();
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS1:
			getStimulus1().clear();
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS3:
			getStimulus3().clear();
			return;
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			setComponentInstance((ComponentInstance) null);
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS2:
			getStimulus2().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.INSTANCE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case Common_behaviorPackage.INSTANCE__BINDING:
			return binding != null;
		case Common_behaviorPackage.INSTANCE__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			return stereotype != null;
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.INSTANCE__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			return classifier != null && !classifier.isEmpty();
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			return attributeLink != null && !attributeLink.isEmpty();
		case Common_behaviorPackage.INSTANCE__LINK_END:
			return linkEnd != null && !linkEnd.isEmpty();
		case Common_behaviorPackage.INSTANCE__SLOT:
			return slot != null && !slot.isEmpty();
		case Common_behaviorPackage.INSTANCE__STIMULUS1:
			return stimulus1 != null && !stimulus1.isEmpty();
		case Common_behaviorPackage.INSTANCE__STIMULUS3:
			return stimulus3 != null && !stimulus3.isEmpty();
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			return componentInstance != null;
		case Common_behaviorPackage.INSTANCE__STIMULUS2:
			return stimulus2 != null && !stimulus2.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // InstanceImpl
