/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Activity_graphsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.ClassifierInState;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.CompositeState;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Event;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.state_machines.Transition;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>State</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.StateImpl#getEntry
 * <em>Entry</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.StateImpl#getExit
 * <em>Exit</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.StateImpl#getStateMachine
 * <em>State Machine</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.StateImpl#getDeferrableEvent
 * <em>Deferrable Event</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.StateImpl#getInternalTransition
 * <em>Internal Transition</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.StateImpl#getDoActivity
 * <em>Do Activity</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.impl.StateImpl#getClassifierInState
 * <em>Classifier In State</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class StateImpl extends StateVertexImpl implements State {
	/**
	 * The cached value of the '{@link #getEntry() <em>Entry</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getEntry()
	 * @generated
	 * @ordered
	 */
	protected Action entry = null;

	/**
	 * The cached value of the '{@link #getExit() <em>Exit</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getExit()
	 * @generated
	 * @ordered
	 */
	protected Action exit = null;

	/**
	 * The cached value of the '{@link #getDeferrableEvent()
	 * <em>Deferrable Event</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getDeferrableEvent()
	 * @generated
	 * @ordered
	 */
	protected EList deferrableEvent = null;

	/**
	 * The cached value of the '{@link #getInternalTransition()
	 * <em>Internal Transition</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInternalTransition()
	 * @generated
	 * @ordered
	 */
	protected EList internalTransition = null;

	/**
	 * The cached value of the '{@link #getDoActivity() <em>Do Activity</em>}'
	 * containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getDoActivity()
	 * @generated
	 * @ordered
	 */
	protected Action doActivity = null;

	/**
	 * The cached value of the '{@link #getClassifierInState()
	 * <em>Classifier In State</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getClassifierInState()
	 * @generated
	 * @ordered
	 */
	protected EList classifierInState = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected StateImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return State_machinesPackage.eINSTANCE.getState();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action getEntry() {
		return entry;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetEntry(Action newEntry, NotificationChain msgs) {
		Action oldEntry = entry;
		entry = newEntry;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE__ENTRY, oldEntry, newEntry);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setEntry(Action newEntry) {
		if (newEntry != entry) {
			NotificationChain msgs = null;
			if (entry != null)
				msgs = ((InternalEObject) entry).eInverseRemove(this, Common_behaviorPackage.ACTION__STATE1, Action.class, msgs);
			if (newEntry != null)
				msgs = ((InternalEObject) newEntry).eInverseAdd(this, Common_behaviorPackage.ACTION__STATE1, Action.class, msgs);
			msgs = basicSetEntry(newEntry, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE__ENTRY, newEntry, newEntry));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action getExit() {
		return exit;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetExit(Action newExit, NotificationChain msgs) {
		Action oldExit = exit;
		exit = newExit;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE__EXIT, oldExit, newExit);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setExit(Action newExit) {
		if (newExit != exit) {
			NotificationChain msgs = null;
			if (exit != null)
				msgs = ((InternalEObject) exit).eInverseRemove(this, Common_behaviorPackage.ACTION__STATE2, Action.class, msgs);
			if (newExit != null)
				msgs = ((InternalEObject) newExit).eInverseAdd(this, Common_behaviorPackage.ACTION__STATE2, Action.class, msgs);
			msgs = basicSetExit(newExit, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE__EXIT, newExit, newExit));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public StateMachine getStateMachine() {
		if (eContainerFeatureID != State_machinesPackage.STATE__STATE_MACHINE)
			return null;
		return (StateMachine) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setStateMachine(StateMachine newStateMachine) {
		if (newStateMachine != eContainer || (eContainerFeatureID != State_machinesPackage.STATE__STATE_MACHINE && newStateMachine != null)) {
			if (EcoreUtil.isAncestor(this, newStateMachine))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newStateMachine != null)
				msgs = ((InternalEObject) newStateMachine).eInverseAdd(this, State_machinesPackage.STATE_MACHINE__TOP, StateMachine.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newStateMachine, State_machinesPackage.STATE__STATE_MACHINE, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE__STATE_MACHINE, newStateMachine, newStateMachine));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getDeferrableEvent() {
		if (deferrableEvent == null) {
			deferrableEvent = new EObjectWithInverseResolvingEList.ManyInverse(Event.class, this, State_machinesPackage.STATE__DEFERRABLE_EVENT, State_machinesPackage.EVENT__STATE);
		}
		return deferrableEvent;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getInternalTransition() {
		if (internalTransition == null) {
			internalTransition = new EObjectContainmentWithInverseEList(Transition.class, this, State_machinesPackage.STATE__INTERNAL_TRANSITION, State_machinesPackage.TRANSITION__STATE);
		}
		return internalTransition;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Action getDoActivity() {
		return doActivity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetDoActivity(Action newDoActivity, NotificationChain msgs) {
		Action oldDoActivity = doActivity;
		doActivity = newDoActivity;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE__DO_ACTIVITY, oldDoActivity, newDoActivity);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setDoActivity(Action newDoActivity) {
		if (newDoActivity != doActivity) {
			NotificationChain msgs = null;
			if (doActivity != null)
				msgs = ((InternalEObject) doActivity).eInverseRemove(this, Common_behaviorPackage.ACTION__STATE3, Action.class, msgs);
			if (newDoActivity != null)
				msgs = ((InternalEObject) newDoActivity).eInverseAdd(this, Common_behaviorPackage.ACTION__STATE3, Action.class, msgs);
			msgs = basicSetDoActivity(newDoActivity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE__DO_ACTIVITY, newDoActivity, newDoActivity));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getClassifierInState() {
		if (classifierInState == null) {
			classifierInState = new EObjectWithInverseResolvingEList.ManyInverse(ClassifierInState.class, this, State_machinesPackage.STATE__CLASSIFIER_IN_STATE,
					Activity_graphsPackage.CLASSIFIER_IN_STATE__IN_STATE);
		}
		return classifierInState;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case State_machinesPackage.STATE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.STATE__NAMESPACE, msgs);
			case State_machinesPackage.STATE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case State_machinesPackage.STATE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case State_machinesPackage.STATE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__CONTAINER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.STATE__CONTAINER, msgs);
			case State_machinesPackage.STATE__OUTGOING:
				return ((InternalEList) getOutgoing()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__INCOMING:
				return ((InternalEList) getIncoming()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__ENTRY:
				if (entry != null)
					msgs = ((InternalEObject) entry).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - State_machinesPackage.STATE__ENTRY, null, msgs);
				return basicSetEntry((Action) otherEnd, msgs);
			case State_machinesPackage.STATE__EXIT:
				if (exit != null)
					msgs = ((InternalEObject) exit).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - State_machinesPackage.STATE__EXIT, null, msgs);
				return basicSetExit((Action) otherEnd, msgs);
			case State_machinesPackage.STATE__STATE_MACHINE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.STATE__STATE_MACHINE, msgs);
			case State_machinesPackage.STATE__DEFERRABLE_EVENT:
				return ((InternalEList) getDeferrableEvent()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__INTERNAL_TRANSITION:
				return ((InternalEList) getInternalTransition()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE__DO_ACTIVITY:
				if (doActivity != null)
					msgs = ((InternalEObject) doActivity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - State_machinesPackage.STATE__DO_ACTIVITY, null, msgs);
				return basicSetDoActivity((Action) otherEnd, msgs);
			case State_machinesPackage.STATE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case State_machinesPackage.STATE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__NAMESPACE:
				return eBasicSetContainer(null, State_machinesPackage.STATE__NAMESPACE, msgs);
			case State_machinesPackage.STATE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__BINDING:
				return basicSetBinding(null, msgs);
			case State_machinesPackage.STATE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case State_machinesPackage.STATE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__CONTAINER:
				return eBasicSetContainer(null, State_machinesPackage.STATE__CONTAINER, msgs);
			case State_machinesPackage.STATE__OUTGOING:
				return ((InternalEList) getOutgoing()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__INCOMING:
				return ((InternalEList) getIncoming()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__ENTRY:
				return basicSetEntry(null, msgs);
			case State_machinesPackage.STATE__EXIT:
				return basicSetExit(null, msgs);
			case State_machinesPackage.STATE__STATE_MACHINE:
				return eBasicSetContainer(null, State_machinesPackage.STATE__STATE_MACHINE, msgs);
			case State_machinesPackage.STATE__DEFERRABLE_EVENT:
				return ((InternalEList) getDeferrableEvent()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__INTERNAL_TRANSITION:
				return ((InternalEList) getInternalTransition()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE__DO_ACTIVITY:
				return basicSetDoActivity(null, msgs);
			case State_machinesPackage.STATE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case State_machinesPackage.STATE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case State_machinesPackage.STATE__CONTAINER:
				return eContainer.eInverseRemove(this, State_machinesPackage.COMPOSITE_STATE__SUBVERTEX, CompositeState.class, msgs);
			case State_machinesPackage.STATE__STATE_MACHINE:
				return eContainer.eInverseRemove(this, State_machinesPackage.STATE_MACHINE__TOP, StateMachine.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE__ELEMENT_IMPORT:
			return getElementImport();
		case State_machinesPackage.STATE__NAME:
			return getName();
		case State_machinesPackage.STATE__VISIBILITY:
			return getVisibility();
		case State_machinesPackage.STATE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case State_machinesPackage.STATE__NAMESPACE:
			return getNamespace();
		case State_machinesPackage.STATE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case State_machinesPackage.STATE__CONSTRAINT:
			return getConstraint();
		case State_machinesPackage.STATE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case State_machinesPackage.STATE__PRESENTATION:
			return getPresentation();
		case State_machinesPackage.STATE__TARGET_FLOW:
			return getTargetFlow();
		case State_machinesPackage.STATE__SOURCE_FLOW:
			return getSourceFlow();
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case State_machinesPackage.STATE__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case State_machinesPackage.STATE__COMMENT:
			return getComment();
		case State_machinesPackage.STATE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case State_machinesPackage.STATE__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case State_machinesPackage.STATE__TAGGED_VALUE:
			return getTaggedValue();
		case State_machinesPackage.STATE__BEHAVIOR:
			return getBehavior();
		case State_machinesPackage.STATE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case State_machinesPackage.STATE__COLLABORATION:
			return getCollaboration();
		case State_machinesPackage.STATE__PARTITION:
			return getPartition();
		case State_machinesPackage.STATE__CONTAINER:
			return getContainer();
		case State_machinesPackage.STATE__OUTGOING:
			return getOutgoing();
		case State_machinesPackage.STATE__INCOMING:
			return getIncoming();
		case State_machinesPackage.STATE__ENTRY:
			return getEntry();
		case State_machinesPackage.STATE__EXIT:
			return getExit();
		case State_machinesPackage.STATE__STATE_MACHINE:
			return getStateMachine();
		case State_machinesPackage.STATE__DEFERRABLE_EVENT:
			return getDeferrableEvent();
		case State_machinesPackage.STATE__INTERNAL_TRANSITION:
			return getInternalTransition();
		case State_machinesPackage.STATE__DO_ACTIVITY:
			return getDoActivity();
		case State_machinesPackage.STATE__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__NAME:
			setName((String) newValue);
			return;
		case State_machinesPackage.STATE__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case State_machinesPackage.STATE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case State_machinesPackage.STATE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case State_machinesPackage.STATE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__BINDING:
			setBinding((Binding) newValue);
			return;
		case State_machinesPackage.STATE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case State_machinesPackage.STATE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__CONTAINER:
			setContainer((CompositeState) newValue);
			return;
		case State_machinesPackage.STATE__OUTGOING:
			getOutgoing().clear();
			getOutgoing().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__INCOMING:
			getIncoming().clear();
			getIncoming().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__ENTRY:
			setEntry((Action) newValue);
			return;
		case State_machinesPackage.STATE__EXIT:
			setExit((Action) newValue);
			return;
		case State_machinesPackage.STATE__STATE_MACHINE:
			setStateMachine((StateMachine) newValue);
			return;
		case State_machinesPackage.STATE__DEFERRABLE_EVENT:
			getDeferrableEvent().clear();
			getDeferrableEvent().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__INTERNAL_TRANSITION:
			getInternalTransition().clear();
			getInternalTransition().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE__DO_ACTIVITY:
			setDoActivity((Action) newValue);
			return;
		case State_machinesPackage.STATE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case State_machinesPackage.STATE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case State_machinesPackage.STATE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case State_machinesPackage.STATE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case State_machinesPackage.STATE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case State_machinesPackage.STATE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case State_machinesPackage.STATE__CONSTRAINT:
			getConstraint().clear();
			return;
		case State_machinesPackage.STATE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case State_machinesPackage.STATE__PRESENTATION:
			getPresentation().clear();
			return;
		case State_machinesPackage.STATE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case State_machinesPackage.STATE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case State_machinesPackage.STATE__BINDING:
			setBinding((Binding) null);
			return;
		case State_machinesPackage.STATE__COMMENT:
			getComment().clear();
			return;
		case State_machinesPackage.STATE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case State_machinesPackage.STATE__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case State_machinesPackage.STATE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case State_machinesPackage.STATE__BEHAVIOR:
			getBehavior().clear();
			return;
		case State_machinesPackage.STATE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case State_machinesPackage.STATE__COLLABORATION:
			getCollaboration().clear();
			return;
		case State_machinesPackage.STATE__PARTITION:
			getPartition().clear();
			return;
		case State_machinesPackage.STATE__CONTAINER:
			setContainer((CompositeState) null);
			return;
		case State_machinesPackage.STATE__OUTGOING:
			getOutgoing().clear();
			return;
		case State_machinesPackage.STATE__INCOMING:
			getIncoming().clear();
			return;
		case State_machinesPackage.STATE__ENTRY:
			setEntry((Action) null);
			return;
		case State_machinesPackage.STATE__EXIT:
			setExit((Action) null);
			return;
		case State_machinesPackage.STATE__STATE_MACHINE:
			setStateMachine((StateMachine) null);
			return;
		case State_machinesPackage.STATE__DEFERRABLE_EVENT:
			getDeferrableEvent().clear();
			return;
		case State_machinesPackage.STATE__INTERNAL_TRANSITION:
			getInternalTransition().clear();
			return;
		case State_machinesPackage.STATE__DO_ACTIVITY:
			setDoActivity((Action) null);
			return;
		case State_machinesPackage.STATE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case State_machinesPackage.STATE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case State_machinesPackage.STATE__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case State_machinesPackage.STATE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case State_machinesPackage.STATE__NAMESPACE:
			return getNamespace() != null;
		case State_machinesPackage.STATE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case State_machinesPackage.STATE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case State_machinesPackage.STATE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case State_machinesPackage.STATE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case State_machinesPackage.STATE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case State_machinesPackage.STATE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case State_machinesPackage.STATE__BINDING:
			return binding != null;
		case State_machinesPackage.STATE__COMMENT:
			return comment != null && !comment.isEmpty();
		case State_machinesPackage.STATE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case State_machinesPackage.STATE__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case State_machinesPackage.STATE__STEREOTYPE:
			return stereotype != null;
		case State_machinesPackage.STATE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case State_machinesPackage.STATE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case State_machinesPackage.STATE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case State_machinesPackage.STATE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case State_machinesPackage.STATE__PARTITION:
			return partition != null && !partition.isEmpty();
		case State_machinesPackage.STATE__CONTAINER:
			return getContainer() != null;
		case State_machinesPackage.STATE__OUTGOING:
			return outgoing != null && !outgoing.isEmpty();
		case State_machinesPackage.STATE__INCOMING:
			return incoming != null && !incoming.isEmpty();
		case State_machinesPackage.STATE__ENTRY:
			return entry != null;
		case State_machinesPackage.STATE__EXIT:
			return exit != null;
		case State_machinesPackage.STATE__STATE_MACHINE:
			return getStateMachine() != null;
		case State_machinesPackage.STATE__DEFERRABLE_EVENT:
			return deferrableEvent != null && !deferrableEvent.isEmpty();
		case State_machinesPackage.STATE__INTERNAL_TRANSITION:
			return internalTransition != null && !internalTransition.isEmpty();
		case State_machinesPackage.STATE__DO_ACTIVITY:
			return doActivity != null;
		case State_machinesPackage.STATE__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // StateImpl
