/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.use_cases.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.use_cases.Extend;
import fr.obeo.acceleo.uml13.behavioral_elements.use_cases.ExtensionPoint;
import fr.obeo.acceleo.uml13.behavioral_elements.use_cases.Include;
import fr.obeo.acceleo.uml13.behavioral_elements.use_cases.UseCase;
import fr.obeo.acceleo.uml13.behavioral_elements.use_cases.Use_casesPackage;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.core.impl.ClassifierImpl;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Use Case</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.use_cases.impl.UseCaseImpl#getExtend2
 * <em>Extend2</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.use_cases.impl.UseCaseImpl#getExtend
 * <em>Extend</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.use_cases.impl.UseCaseImpl#getInclude
 * <em>Include</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.use_cases.impl.UseCaseImpl#getInclude2
 * <em>Include2</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.use_cases.impl.UseCaseImpl#getExtensionPoint
 * <em>Extension Point</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class UseCaseImpl extends ClassifierImpl implements UseCase {
	/**
	 * The cached value of the '{@link #getExtend2() <em>Extend2</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getExtend2()
	 * @generated
	 * @ordered
	 */
	protected EList extend2 = null;

	/**
	 * The cached value of the '{@link #getExtend() <em>Extend</em>}' reference
	 * list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getExtend()
	 * @generated
	 * @ordered
	 */
	protected EList extend = null;

	/**
	 * The cached value of the '{@link #getInclude() <em>Include</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInclude()
	 * @generated
	 * @ordered
	 */
	protected EList include = null;

	/**
	 * The cached value of the '{@link #getInclude2() <em>Include2</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInclude2()
	 * @generated
	 * @ordered
	 */
	protected EList include2 = null;

	/**
	 * The cached value of the '{@link #getExtensionPoint()
	 * <em>Extension Point</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getExtensionPoint()
	 * @generated
	 * @ordered
	 */
	protected EList extensionPoint = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected UseCaseImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Use_casesPackage.eINSTANCE.getUseCase();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getExtend2() {
		if (extend2 == null) {
			extend2 = new EObjectWithInverseResolvingEList(Extend.class, this, Use_casesPackage.USE_CASE__EXTEND2, Use_casesPackage.EXTEND__BASE);
		}
		return extend2;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getExtend() {
		if (extend == null) {
			extend = new EObjectWithInverseResolvingEList(Extend.class, this, Use_casesPackage.USE_CASE__EXTEND, Use_casesPackage.EXTEND__EXTENSION);
		}
		return extend;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getInclude() {
		if (include == null) {
			include = new EObjectWithInverseResolvingEList(Include.class, this, Use_casesPackage.USE_CASE__INCLUDE, Use_casesPackage.INCLUDE__ADDITION);
		}
		return include;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getInclude2() {
		if (include2 == null) {
			include2 = new EObjectWithInverseResolvingEList(Include.class, this, Use_casesPackage.USE_CASE__INCLUDE2, Use_casesPackage.INCLUDE__BASE);
		}
		return include2;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getExtensionPoint() {
		if (extensionPoint == null) {
			extensionPoint = new EObjectWithInverseResolvingEList(ExtensionPoint.class, this, Use_casesPackage.USE_CASE__EXTENSION_POINT, Use_casesPackage.EXTENSION_POINT__USE_CASE);
		}
		return extensionPoint;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Use_casesPackage.USE_CASE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Use_casesPackage.USE_CASE__NAMESPACE, msgs);
			case Use_casesPackage.USE_CASE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case Use_casesPackage.USE_CASE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__FEATURE:
				return ((InternalEList) getFeature()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__PARTICIPANT:
				return ((InternalEList) getParticipant()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__INSTANCE:
				return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__EXTEND2:
				return ((InternalEList) getExtend2()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__EXTEND:
				return ((InternalEList) getExtend()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__INCLUDE:
				return ((InternalEList) getInclude()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__INCLUDE2:
				return ((InternalEList) getInclude2()).basicAdd(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__EXTENSION_POINT:
				return ((InternalEList) getExtensionPoint()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Use_casesPackage.USE_CASE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__NAMESPACE:
				return eBasicSetContainer(null, Use_casesPackage.USE_CASE__NAMESPACE, msgs);
			case Use_casesPackage.USE_CASE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__BINDING:
				return basicSetBinding(null, msgs);
			case Use_casesPackage.USE_CASE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case Use_casesPackage.USE_CASE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__FEATURE:
				return ((InternalEList) getFeature()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__PARTICIPANT:
				return ((InternalEList) getParticipant()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__INSTANCE:
				return ((InternalEList) getInstance()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__EXTEND2:
				return ((InternalEList) getExtend2()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__EXTEND:
				return ((InternalEList) getExtend()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__INCLUDE:
				return ((InternalEList) getInclude()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__INCLUDE2:
				return ((InternalEList) getInclude2()).basicRemove(otherEnd, msgs);
			case Use_casesPackage.USE_CASE__EXTENSION_POINT:
				return ((InternalEList) getExtensionPoint()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Use_casesPackage.USE_CASE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Use_casesPackage.USE_CASE__ELEMENT_IMPORT:
			return getElementImport();
		case Use_casesPackage.USE_CASE__NAME:
			return getName();
		case Use_casesPackage.USE_CASE__VISIBILITY:
			return getVisibility();
		case Use_casesPackage.USE_CASE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Use_casesPackage.USE_CASE__NAMESPACE:
			return getNamespace();
		case Use_casesPackage.USE_CASE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Use_casesPackage.USE_CASE__CONSTRAINT:
			return getConstraint();
		case Use_casesPackage.USE_CASE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Use_casesPackage.USE_CASE__PRESENTATION:
			return getPresentation();
		case Use_casesPackage.USE_CASE__TARGET_FLOW:
			return getTargetFlow();
		case Use_casesPackage.USE_CASE__SOURCE_FLOW:
			return getSourceFlow();
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case Use_casesPackage.USE_CASE__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case Use_casesPackage.USE_CASE__COMMENT:
			return getComment();
		case Use_casesPackage.USE_CASE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case Use_casesPackage.USE_CASE__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case Use_casesPackage.USE_CASE__TAGGED_VALUE:
			return getTaggedValue();
		case Use_casesPackage.USE_CASE__BEHAVIOR:
			return getBehavior();
		case Use_casesPackage.USE_CASE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Use_casesPackage.USE_CASE__COLLABORATION:
			return getCollaboration();
		case Use_casesPackage.USE_CASE__PARTITION:
			return getPartition();
		case Use_casesPackage.USE_CASE__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case Use_casesPackage.USE_CASE__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case Use_casesPackage.USE_CASE__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case Use_casesPackage.USE_CASE__GENERALIZATION:
			return getGeneralization();
		case Use_casesPackage.USE_CASE__SPECIALIZATION:
			return getSpecialization();
		case Use_casesPackage.USE_CASE__OWNED_ELEMENT:
			return getOwnedElement();
		case Use_casesPackage.USE_CASE__FEATURE:
			return getFeature();
		case Use_casesPackage.USE_CASE__PARTICIPANT:
			return getParticipant();
		case Use_casesPackage.USE_CASE__POWERTYPE_RANGE:
			return getPowertypeRange();
		case Use_casesPackage.USE_CASE__INSTANCE:
			return getInstance();
		case Use_casesPackage.USE_CASE__CREATE_ACTION:
			return getCreateAction();
		case Use_casesPackage.USE_CASE__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case Use_casesPackage.USE_CASE__OBJECT_FLOW_STATE:
			return getObjectFlowState();
		case Use_casesPackage.USE_CASE__EXTEND2:
			return getExtend2();
		case Use_casesPackage.USE_CASE__EXTEND:
			return getExtend();
		case Use_casesPackage.USE_CASE__INCLUDE:
			return getInclude();
		case Use_casesPackage.USE_CASE__INCLUDE2:
			return getInclude2();
		case Use_casesPackage.USE_CASE__EXTENSION_POINT:
			return getExtensionPoint();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Use_casesPackage.USE_CASE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__NAME:
			setName((String) newValue);
			return;
		case Use_casesPackage.USE_CASE__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case Use_casesPackage.USE_CASE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Use_casesPackage.USE_CASE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Use_casesPackage.USE_CASE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__BINDING:
			setBinding((Binding) newValue);
			return;
		case Use_casesPackage.USE_CASE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case Use_casesPackage.USE_CASE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case Use_casesPackage.USE_CASE__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case Use_casesPackage.USE_CASE__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case Use_casesPackage.USE_CASE__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__OWNED_ELEMENT:
			getOwnedElement().clear();
			getOwnedElement().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__FEATURE:
			getFeature().clear();
			getFeature().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__PARTICIPANT:
			getParticipant().clear();
			getParticipant().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			getPowertypeRange().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__INSTANCE:
			getInstance().clear();
			getInstance().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__CREATE_ACTION:
			getCreateAction().clear();
			getCreateAction().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			getObjectFlowState().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__EXTEND2:
			getExtend2().clear();
			getExtend2().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__EXTEND:
			getExtend().clear();
			getExtend().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__INCLUDE:
			getInclude().clear();
			getInclude().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__INCLUDE2:
			getInclude2().clear();
			getInclude2().addAll((Collection) newValue);
			return;
		case Use_casesPackage.USE_CASE__EXTENSION_POINT:
			getExtensionPoint().clear();
			getExtensionPoint().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Use_casesPackage.USE_CASE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Use_casesPackage.USE_CASE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Use_casesPackage.USE_CASE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Use_casesPackage.USE_CASE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Use_casesPackage.USE_CASE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Use_casesPackage.USE_CASE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Use_casesPackage.USE_CASE__CONSTRAINT:
			getConstraint().clear();
			return;
		case Use_casesPackage.USE_CASE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Use_casesPackage.USE_CASE__PRESENTATION:
			getPresentation().clear();
			return;
		case Use_casesPackage.USE_CASE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Use_casesPackage.USE_CASE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case Use_casesPackage.USE_CASE__BINDING:
			setBinding((Binding) null);
			return;
		case Use_casesPackage.USE_CASE__COMMENT:
			getComment().clear();
			return;
		case Use_casesPackage.USE_CASE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case Use_casesPackage.USE_CASE__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case Use_casesPackage.USE_CASE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Use_casesPackage.USE_CASE__BEHAVIOR:
			getBehavior().clear();
			return;
		case Use_casesPackage.USE_CASE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Use_casesPackage.USE_CASE__COLLABORATION:
			getCollaboration().clear();
			return;
		case Use_casesPackage.USE_CASE__PARTITION:
			getPartition().clear();
			return;
		case Use_casesPackage.USE_CASE__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case Use_casesPackage.USE_CASE__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case Use_casesPackage.USE_CASE__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case Use_casesPackage.USE_CASE__GENERALIZATION:
			getGeneralization().clear();
			return;
		case Use_casesPackage.USE_CASE__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case Use_casesPackage.USE_CASE__OWNED_ELEMENT:
			getOwnedElement().clear();
			return;
		case Use_casesPackage.USE_CASE__FEATURE:
			getFeature().clear();
			return;
		case Use_casesPackage.USE_CASE__PARTICIPANT:
			getParticipant().clear();
			return;
		case Use_casesPackage.USE_CASE__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			return;
		case Use_casesPackage.USE_CASE__INSTANCE:
			getInstance().clear();
			return;
		case Use_casesPackage.USE_CASE__CREATE_ACTION:
			getCreateAction().clear();
			return;
		case Use_casesPackage.USE_CASE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case Use_casesPackage.USE_CASE__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			return;
		case Use_casesPackage.USE_CASE__EXTEND2:
			getExtend2().clear();
			return;
		case Use_casesPackage.USE_CASE__EXTEND:
			getExtend().clear();
			return;
		case Use_casesPackage.USE_CASE__INCLUDE:
			getInclude().clear();
			return;
		case Use_casesPackage.USE_CASE__INCLUDE2:
			getInclude2().clear();
			return;
		case Use_casesPackage.USE_CASE__EXTENSION_POINT:
			getExtensionPoint().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Use_casesPackage.USE_CASE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Use_casesPackage.USE_CASE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Use_casesPackage.USE_CASE__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case Use_casesPackage.USE_CASE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Use_casesPackage.USE_CASE__NAMESPACE:
			return getNamespace() != null;
		case Use_casesPackage.USE_CASE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Use_casesPackage.USE_CASE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Use_casesPackage.USE_CASE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Use_casesPackage.USE_CASE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Use_casesPackage.USE_CASE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Use_casesPackage.USE_CASE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case Use_casesPackage.USE_CASE__BINDING:
			return binding != null;
		case Use_casesPackage.USE_CASE__COMMENT:
			return comment != null && !comment.isEmpty();
		case Use_casesPackage.USE_CASE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Use_casesPackage.USE_CASE__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case Use_casesPackage.USE_CASE__STEREOTYPE:
			return stereotype != null;
		case Use_casesPackage.USE_CASE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Use_casesPackage.USE_CASE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Use_casesPackage.USE_CASE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Use_casesPackage.USE_CASE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Use_casesPackage.USE_CASE__PARTITION:
			return partition != null && !partition.isEmpty();
		case Use_casesPackage.USE_CASE__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case Use_casesPackage.USE_CASE__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case Use_casesPackage.USE_CASE__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case Use_casesPackage.USE_CASE__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case Use_casesPackage.USE_CASE__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case Use_casesPackage.USE_CASE__OWNED_ELEMENT:
			return ownedElement != null && !ownedElement.isEmpty();
		case Use_casesPackage.USE_CASE__FEATURE:
			return feature != null && !feature.isEmpty();
		case Use_casesPackage.USE_CASE__PARTICIPANT:
			return participant != null && !participant.isEmpty();
		case Use_casesPackage.USE_CASE__POWERTYPE_RANGE:
			return powertypeRange != null && !powertypeRange.isEmpty();
		case Use_casesPackage.USE_CASE__INSTANCE:
			return instance != null && !instance.isEmpty();
		case Use_casesPackage.USE_CASE__CREATE_ACTION:
			return createAction != null && !createAction.isEmpty();
		case Use_casesPackage.USE_CASE__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case Use_casesPackage.USE_CASE__OBJECT_FLOW_STATE:
			return objectFlowState != null && !objectFlowState.isEmpty();
		case Use_casesPackage.USE_CASE__EXTEND2:
			return extend2 != null && !extend2.isEmpty();
		case Use_casesPackage.USE_CASE__EXTEND:
			return extend != null && !extend.isEmpty();
		case Use_casesPackage.USE_CASE__INCLUDE:
			return include != null && !include.isEmpty();
		case Use_casesPackage.USE_CASE__INCLUDE2:
			return include2 != null && !include2.isEmpty();
		case Use_casesPackage.USE_CASE__EXTENSION_POINT:
			return extensionPoint != null && !extensionPoint.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // UseCaseImpl
