/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.core;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Model Element</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getElementImport
 * <em>Element Import</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getName <em>
 * Name</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getVisibility
 * <em>Visibility</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#isIsSpecification
 * <em>Is Specification</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getNamespace
 * <em>Namespace</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getClientDependency
 * <em>Client Dependency</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getConstraint
 * <em>Constraint</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getSupplierDependency
 * <em>Supplier Dependency</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getPresentation
 * <em>Presentation</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getTargetFlow
 * <em>Target Flow</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getSourceFlow
 * <em>Source Flow</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getTemplateParameter3
 * <em>Template Parameter3</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getBinding <em>
 * Binding</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getComment <em>
 * Comment</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getElementResidence
 * <em>Element Residence</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getTemplateParameter
 * <em>Template Parameter</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getTemplateParameter2
 * <em>Template Parameter2</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getStereotype
 * <em>Stereotype</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getTaggedValue
 * <em>Tagged Value</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getBehavior
 * <em>Behavior</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getClassifierRole
 * <em>Classifier Role</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getCollaboration
 * <em>Collaboration</em>}</li>
 * <li>{@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getPartition
 * <em>Partition</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement()
 * @model abstract="true"
 * @generated
 */
public interface ModelElement extends Element {
	/**
	 * Returns the value of the '<em><b>Element Import</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.model_management.ElementImport}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.model_management.ElementImport#getModelElement
	 * <em>Model Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Element Import</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Element Import</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_ElementImport()
	 * @see fr.obeo.acceleo.uml13.model_management.ElementImport#getModelElement
	 * @model type="fr.obeo.acceleo.uml13.model_management.ElementImport"
	 *        opposite="modelElement"
	 * @generated
	 */
	EList getElementImport();

	/**
	 * Returns the value of the '<em><b>Name</b></em>' attribute. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Name</em>' attribute isn't clear, there really
	 * should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Name</em>' attribute.
	 * @see #setName(String)
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Name()
	 * @model dataType="fr.obeo.acceleo.uml13.foundation.data_types.Name"
	 * @generated
	 */
	String getName();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getName
	 * <em>Name</em>}' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Name</em>' attribute.
	 * @see #getName()
	 * @generated
	 */
	void setName(String value);

	/**
	 * Returns the value of the '<em><b>Visibility</b></em>' attribute. <!--
	 * begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Visibility</em>' attribute isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Visibility</em>' attribute.
	 * @see #setVisibility(String)
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Visibility()
	 * @model 
	 *        dataType="fr.obeo.acceleo.uml13.foundation.data_types.VisibilityKind"
	 * @generated
	 */
	String getVisibility();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getVisibility
	 * <em>Visibility</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Visibility</em>' attribute.
	 * @see #getVisibility()
	 * @generated
	 */
	void setVisibility(String value);

	/**
	 * Returns the value of the '<em><b>Is Specification</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Is Specification</em>' attribute isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Is Specification</em>' attribute.
	 * @see #setIsSpecification(boolean)
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_IsSpecification()
	 * @model dataType="fr.obeo.acceleo.uml13.foundation.data_types.Boolean"
	 * @generated
	 */
	boolean isIsSpecification();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#isIsSpecification
	 * <em>Is Specification</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Is Specification</em>' attribute.
	 * @see #isIsSpecification()
	 * @generated
	 */
	void setIsSpecification(boolean value);

	/**
	 * Returns the value of the '<em><b>Namespace</b></em>' container reference.
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Namespace#getOwnedElement
	 * <em>Owned Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Namespace</em>' container reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Namespace</em>' container reference.
	 * @see #setNamespace(Namespace)
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Namespace()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Namespace#getOwnedElement
	 * @model opposite="ownedElement"
	 * @generated
	 */
	Namespace getNamespace();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getNamespace
	 * <em>Namespace</em>}' container reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Namespace</em>' container reference.
	 * @see #getNamespace()
	 * @generated
	 */
	void setNamespace(Namespace value);

	/**
	 * Returns the value of the '<em><b>Client Dependency</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Dependency}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Dependency#getClient
	 * <em>Client</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Client Dependency</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Client Dependency</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_ClientDependency()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Dependency#getClient
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Dependency"
	 *        opposite="client"
	 * @generated
	 */
	EList getClientDependency();

	/**
	 * Returns the value of the '<em><b>Constraint</b></em>' reference list. The
	 * list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Constraint}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Constraint#getConstrainedElement
	 * <em>Constrained Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Constraint</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Constraint</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Constraint()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Constraint#getConstrainedElement
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Constraint"
	 *        opposite="constrainedElement"
	 * @generated
	 */
	EList getConstraint();

	/**
	 * Returns the value of the '<em><b>Supplier Dependency</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Dependency}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Dependency#getSupplier
	 * <em>Supplier</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Supplier Dependency</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Supplier Dependency</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_SupplierDependency()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Dependency#getSupplier
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Dependency"
	 *        opposite="supplier"
	 * @generated
	 */
	EList getSupplierDependency();

	/**
	 * Returns the value of the '<em><b>Presentation</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.PresentationElement}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.PresentationElement#getSubject
	 * <em>Subject</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Presentation</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Presentation</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Presentation()
	 * @see fr.obeo.acceleo.uml13.foundation.core.PresentationElement#getSubject
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.PresentationElement"
	 *        opposite="subject"
	 * @generated
	 */
	EList getPresentation();

	/**
	 * Returns the value of the '<em><b>Target Flow</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Flow}. It is bidirectional
	 * and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Flow#getTarget
	 * <em>Target</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Target Flow</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Target Flow</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_TargetFlow()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Flow#getTarget
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Flow"
	 *        opposite="target"
	 * @generated
	 */
	EList getTargetFlow();

	/**
	 * Returns the value of the '<em><b>Source Flow</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Flow}. It is bidirectional
	 * and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Flow#getSource
	 * <em>Source</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Source Flow</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Source Flow</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_SourceFlow()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Flow#getSource
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Flow"
	 *        opposite="source"
	 * @generated
	 */
	EList getSourceFlow();

	/**
	 * Returns the value of the '<em><b>Template Parameter3</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.TemplateParameter}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.TemplateParameter#getDefaultElement
	 * <em>Default Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Template Parameter3</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Template Parameter3</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_TemplateParameter3()
	 * @see fr.obeo.acceleo.uml13.foundation.core.TemplateParameter#getDefaultElement
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.TemplateParameter"
	 *        opposite="defaultElement"
	 * @generated
	 */
	EList getTemplateParameter3();

	/**
	 * Returns the value of the '<em><b>Binding</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Binding#getArgument
	 * <em>Argument</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Binding</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Binding</em>' reference.
	 * @see #setBinding(Binding)
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Binding()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Binding#getArgument
	 * @model opposite="argument"
	 * @generated
	 */
	Binding getBinding();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getBinding
	 * <em>Binding</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Binding</em>' reference.
	 * @see #getBinding()
	 * @generated
	 */
	void setBinding(Binding value);

	/**
	 * Returns the value of the '<em><b>Comment</b></em>' reference list. The
	 * list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Comment}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.Comment#getAnnotatedElement
	 * <em>Annotated Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Comment</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Comment</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Comment()
	 * @see fr.obeo.acceleo.uml13.foundation.core.Comment#getAnnotatedElement
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.Comment"
	 *        opposite="annotatedElement"
	 * @generated
	 */
	EList getComment();

	/**
	 * Returns the value of the '<em><b>Element Residence</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ElementResidence}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ElementResidence#getResident
	 * <em>Resident</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Element Residence</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Element Residence</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_ElementResidence()
	 * @see fr.obeo.acceleo.uml13.foundation.core.ElementResidence#getResident
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.ElementResidence"
	 *        opposite="resident"
	 * @generated
	 */
	EList getElementResidence();

	/**
	 * Returns the value of the '<em><b>Template Parameter</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.TemplateParameter}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.TemplateParameter#getModelElement
	 * <em>Model Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Template Parameter</em>' containment reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Template Parameter</em>' containment
	 *         reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_TemplateParameter()
	 * @see fr.obeo.acceleo.uml13.foundation.core.TemplateParameter#getModelElement
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.TemplateParameter"
	 *        opposite="modelElement" containment="true"
	 * @generated
	 */
	EList getTemplateParameter();

	/**
	 * Returns the value of the '<em><b>Template Parameter2</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.core.TemplateParameter}. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.TemplateParameter#getModelElement2
	 * <em>Model Element2</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Template Parameter2</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Template Parameter2</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_TemplateParameter2()
	 * @see fr.obeo.acceleo.uml13.foundation.core.TemplateParameter#getModelElement2
	 * @model type="fr.obeo.acceleo.uml13.foundation.core.TemplateParameter"
	 *        opposite="modelElement2"
	 * @generated
	 */
	EList getTemplateParameter2();

	/**
	 * Returns the value of the '<em><b>Stereotype</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype#getExtendedElement
	 * <em>Extended Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Stereotype</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Stereotype</em>' reference.
	 * @see #setStereotype(Stereotype)
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Stereotype()
	 * @see fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype#getExtendedElement
	 * @model opposite="extendedElement"
	 * @generated
	 */
	Stereotype getStereotype();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.foundation.core.ModelElement#getStereotype
	 * <em>Stereotype</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Stereotype</em>' reference.
	 * @see #getStereotype()
	 * @generated
	 */
	void setStereotype(Stereotype value);

	/**
	 * Returns the value of the '<em><b>Tagged Value</b></em>' containment
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.TaggedValue}
	 * . It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.foundation.extension_mechanisms.TaggedValue#getModelElement
	 * <em>Model Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Tagged Value</em>' containment reference list
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Tagged Value</em>' containment reference
	 *         list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_TaggedValue()
	 * @see fr.obeo.acceleo.uml13.foundation.extension_mechanisms.TaggedValue#getModelElement
	 * @model 
	 *        type="fr.obeo.acceleo.uml13.foundation.extension_mechanisms.TaggedValue"
	 *        opposite="modelElement" containment="true"
	 * @generated
	 */
	EList getTaggedValue();

	/**
	 * Returns the value of the '<em><b>Behavior</b></em>' reference list. The
	 * list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine}
	 * . It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine#getContext
	 * <em>Context</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Behavior</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Behavior</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Behavior()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine#getContext
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.state_machines.StateMachine"
	 *        opposite="context"
	 * @generated
	 */
	EList getBehavior();

	/**
	 * Returns the value of the '<em><b>Classifier Role</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole}
	 * . It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole#getAvailableContents
	 * <em>Available Contents</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Classifier Role</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Classifier Role</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_ClassifierRole()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole#getAvailableContents
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole"
	 *        opposite="availableContents"
	 * @generated
	 */
	EList getClassifierRole();

	/**
	 * Returns the value of the '<em><b>Collaboration</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Collaboration}
	 * . It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Collaboration#getConstrainingElement
	 * <em>Constraining Element</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Collaboration</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Collaboration</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Collaboration()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Collaboration#getConstrainingElement
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Collaboration"
	 *        opposite="constrainingElement"
	 * @generated
	 */
	EList getCollaboration();

	/**
	 * Returns the value of the '<em><b>Partition</b></em>' reference list. The
	 * list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Partition}
	 * . It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Partition#getContents
	 * <em>Contents</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Partition</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Partition</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.foundation.core.CorePackage#getModelElement_Partition()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Partition#getContents
	 * @model type=
	 *        "fr.obeo.acceleo.uml13.behavioral_elements.activity_graphs.Partition"
	 *        opposite="contents"
	 * @generated
	 */
	EList getPartition();

} // ModelElement
