/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.foundation.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.AssociationEndRole;
import fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.LinkEnd;
import fr.obeo.acceleo.uml13.foundation.core.Association;
import fr.obeo.acceleo.uml13.foundation.core.AssociationEnd;
import fr.obeo.acceleo.uml13.foundation.core.Attribute;
import fr.obeo.acceleo.uml13.foundation.core.Binding;
import fr.obeo.acceleo.uml13.foundation.core.Classifier;
import fr.obeo.acceleo.uml13.foundation.core.CorePackage;
import fr.obeo.acceleo.uml13.foundation.core.Namespace;
import fr.obeo.acceleo.uml13.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Extension_mechanismsPackage;
import fr.obeo.acceleo.uml13.foundation.extension_mechanisms.Stereotype;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Association End</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#isIsNavigable
 * <em>Is Navigable</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getOrdering
 * <em>Ordering</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getAggregation
 * <em>Aggregation</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getTargetScope
 * <em>Target Scope</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getMultiplicity
 * <em>Multiplicity</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getChangeability
 * <em>Changeability</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getAssociation
 * <em>Association</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getQualifier
 * <em>Qualifier</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getType
 * <em>Type</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getSpecification
 * <em>Specification</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getLinkEnd
 * <em>Link End</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.foundation.core.impl.AssociationEndImpl#getAssociationEndRole
 * <em>Association End Role</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class AssociationEndImpl extends ModelElementImpl implements AssociationEnd {
	/**
	 * The default value of the '{@link #isIsNavigable() <em>Is Navigable</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsNavigable()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_NAVIGABLE_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsNavigable() <em>Is Navigable</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #isIsNavigable()
	 * @generated
	 * @ordered
	 */
	protected boolean isNavigable = IS_NAVIGABLE_EDEFAULT;

	/**
	 * The default value of the '{@link #getOrdering() <em>Ordering</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOrdering()
	 * @generated
	 * @ordered
	 */
	protected static final String ORDERING_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getOrdering() <em>Ordering</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOrdering()
	 * @generated
	 * @ordered
	 */
	protected String ordering = ORDERING_EDEFAULT;

	/**
	 * The default value of the '{@link #getAggregation() <em>Aggregation</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAggregation()
	 * @generated
	 * @ordered
	 */
	protected static final String AGGREGATION_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getAggregation() <em>Aggregation</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getAggregation()
	 * @generated
	 * @ordered
	 */
	protected String aggregation = AGGREGATION_EDEFAULT;

	/**
	 * The default value of the '{@link #getTargetScope() <em>Target Scope</em>}
	 * ' attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTargetScope()
	 * @generated
	 * @ordered
	 */
	protected static final String TARGET_SCOPE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getTargetScope() <em>Target Scope</em>}'
	 * attribute. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTargetScope()
	 * @generated
	 * @ordered
	 */
	protected String targetScope = TARGET_SCOPE_EDEFAULT;

	/**
	 * The cached value of the '{@link #getMultiplicity() <em>Multiplicity</em>}
	 * ' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMultiplicity()
	 * @generated
	 * @ordered
	 */
	protected Multiplicity multiplicity = null;

	/**
	 * The default value of the '{@link #getChangeability()
	 * <em>Changeability</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getChangeability()
	 * @generated
	 * @ordered
	 */
	protected static final String CHANGEABILITY_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getChangeability()
	 * <em>Changeability</em>}' attribute. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getChangeability()
	 * @generated
	 * @ordered
	 */
	protected String changeability = CHANGEABILITY_EDEFAULT;

	/**
	 * The cached value of the '{@link #getQualifier() <em>Qualifier</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getQualifier()
	 * @generated
	 * @ordered
	 */
	protected EList qualifier = null;

	/**
	 * The cached value of the '{@link #getType() <em>Type</em>}' reference.
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getType()
	 * @generated
	 * @ordered
	 */
	protected Classifier type = null;

	/**
	 * The cached value of the '{@link #getSpecification()
	 * <em>Specification</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSpecification()
	 * @generated
	 * @ordered
	 */
	protected EList specification = null;

	/**
	 * The cached value of the '{@link #getLinkEnd() <em>Link End</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getLinkEnd()
	 * @generated
	 * @ordered
	 */
	protected EList linkEnd = null;

	/**
	 * The cached value of the '{@link #getAssociationEndRole()
	 * <em>Association End Role</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getAssociationEndRole()
	 * @generated
	 * @ordered
	 */
	protected EList associationEndRole = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected AssociationEndImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CorePackage.eINSTANCE.getAssociationEnd();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean isIsNavigable() {
		return isNavigable;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setIsNavigable(boolean newIsNavigable) {
		boolean oldIsNavigable = isNavigable;
		isNavigable = newIsNavigable;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__IS_NAVIGABLE, oldIsNavigable, isNavigable));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getOrdering() {
		return ordering;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setOrdering(String newOrdering) {
		String oldOrdering = ordering;
		ordering = newOrdering;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__ORDERING, oldOrdering, ordering));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getAggregation() {
		return aggregation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAggregation(String newAggregation) {
		String oldAggregation = aggregation;
		aggregation = newAggregation;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__AGGREGATION, oldAggregation, aggregation));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getTargetScope() {
		return targetScope;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTargetScope(String newTargetScope) {
		String oldTargetScope = targetScope;
		targetScope = newTargetScope;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__TARGET_SCOPE, oldTargetScope, targetScope));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Multiplicity getMultiplicity() {
		return multiplicity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetMultiplicity(Multiplicity newMultiplicity, NotificationChain msgs) {
		Multiplicity oldMultiplicity = multiplicity;
		multiplicity = newMultiplicity;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__MULTIPLICITY, oldMultiplicity, newMultiplicity);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setMultiplicity(Multiplicity newMultiplicity) {
		if (newMultiplicity != multiplicity) {
			NotificationChain msgs = null;
			if (multiplicity != null)
				msgs = ((InternalEObject) multiplicity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CorePackage.ASSOCIATION_END__MULTIPLICITY, null, msgs);
			if (newMultiplicity != null)
				msgs = ((InternalEObject) newMultiplicity).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CorePackage.ASSOCIATION_END__MULTIPLICITY, null, msgs);
			msgs = basicSetMultiplicity(newMultiplicity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__MULTIPLICITY, newMultiplicity, newMultiplicity));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String getChangeability() {
		return changeability;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setChangeability(String newChangeability) {
		String oldChangeability = changeability;
		changeability = newChangeability;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__CHANGEABILITY, oldChangeability, changeability));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Association getAssociation() {
		if (eContainerFeatureID != CorePackage.ASSOCIATION_END__ASSOCIATION)
			return null;
		return (Association) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setAssociation(Association newAssociation) {
		if (newAssociation != eContainer || (eContainerFeatureID != CorePackage.ASSOCIATION_END__ASSOCIATION && newAssociation != null)) {
			if (EcoreUtil.isAncestor(this, newAssociation))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newAssociation != null)
				msgs = ((InternalEObject) newAssociation).eInverseAdd(this, CorePackage.ASSOCIATION__CONNECTION, Association.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newAssociation, CorePackage.ASSOCIATION_END__ASSOCIATION, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__ASSOCIATION, newAssociation, newAssociation));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getQualifier() {
		if (qualifier == null) {
			qualifier = new EObjectContainmentWithInverseEList(Attribute.class, this, CorePackage.ASSOCIATION_END__QUALIFIER, CorePackage.ATTRIBUTE__ASSOCIATION_END);
		}
		return qualifier;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Classifier getType() {
		if (type != null && type.eIsProxy()) {
			Classifier oldType = type;
			type = (Classifier) eResolveProxy((InternalEObject) type);
			if (type != oldType) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, CorePackage.ASSOCIATION_END__TYPE, oldType, type));
			}
		}
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Classifier basicGetType() {
		return type;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setType(Classifier newType) {
		Classifier oldType = type;
		type = newType;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CorePackage.ASSOCIATION_END__TYPE, oldType, type));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSpecification() {
		if (specification == null) {
			specification = new EObjectWithInverseResolvingEList.ManyInverse(Classifier.class, this, CorePackage.ASSOCIATION_END__SPECIFICATION, CorePackage.CLASSIFIER__PARTICIPANT);
		}
		return specification;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getLinkEnd() {
		if (linkEnd == null) {
			linkEnd = new EObjectWithInverseResolvingEList(LinkEnd.class, this, CorePackage.ASSOCIATION_END__LINK_END, Common_behaviorPackage.LINK_END__ASSOCIATION_END);
		}
		return linkEnd;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAssociationEndRole() {
		if (associationEndRole == null) {
			associationEndRole = new EObjectWithInverseResolvingEList(AssociationEndRole.class, this, CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE,
					CollaborationsPackage.ASSOCIATION_END_ROLE__BASE);
		}
		return associationEndRole;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.ASSOCIATION_END__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.ASSOCIATION_END__NAMESPACE, msgs);
			case CorePackage.ASSOCIATION_END__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__BINDING:
				if (binding != null)
					msgs = ((InternalEObject) binding).eInverseRemove(this, CorePackage.BINDING__ARGUMENT, Binding.class, msgs);
				return basicSetBinding((Binding) otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__STEREOTYPE:
				if (stereotype != null)
					msgs = ((InternalEObject) stereotype).eInverseRemove(this, Extension_mechanismsPackage.STEREOTYPE__EXTENDED_ELEMENT, Stereotype.class, msgs);
				return basicSetStereotype((Stereotype) otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__ASSOCIATION:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.ASSOCIATION_END__ASSOCIATION, msgs);
			case CorePackage.ASSOCIATION_END__QUALIFIER:
				return ((InternalEList) getQualifier()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__SPECIFICATION:
				return ((InternalEList) getSpecification()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__LINK_END:
				return ((InternalEList) getLinkEnd()).basicAdd(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE:
				return ((InternalEList) getAssociationEndRole()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.ASSOCIATION_END__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__NAMESPACE:
				return eBasicSetContainer(null, CorePackage.ASSOCIATION_END__NAMESPACE, msgs);
			case CorePackage.ASSOCIATION_END__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER3:
				return ((InternalEList) getTemplateParameter3()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__BINDING:
				return basicSetBinding(null, msgs);
			case CorePackage.ASSOCIATION_END__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER2:
				return ((InternalEList) getTemplateParameter2()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__STEREOTYPE:
				return basicSetStereotype(null, msgs);
			case CorePackage.ASSOCIATION_END__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__MULTIPLICITY:
				return basicSetMultiplicity(null, msgs);
			case CorePackage.ASSOCIATION_END__ASSOCIATION:
				return eBasicSetContainer(null, CorePackage.ASSOCIATION_END__ASSOCIATION, msgs);
			case CorePackage.ASSOCIATION_END__QUALIFIER:
				return ((InternalEList) getQualifier()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__SPECIFICATION:
				return ((InternalEList) getSpecification()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__LINK_END:
				return ((InternalEList) getLinkEnd()).basicRemove(otherEnd, msgs);
			case CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE:
				return ((InternalEList) getAssociationEndRole()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CorePackage.ASSOCIATION_END__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CorePackage.ASSOCIATION_END__ASSOCIATION:
				return eContainer.eInverseRemove(this, CorePackage.ASSOCIATION__CONNECTION, Association.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ASSOCIATION_END__ELEMENT_IMPORT:
			return getElementImport();
		case CorePackage.ASSOCIATION_END__NAME:
			return getName();
		case CorePackage.ASSOCIATION_END__VISIBILITY:
			return getVisibility();
		case CorePackage.ASSOCIATION_END__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.ASSOCIATION_END__NAMESPACE:
			return getNamespace();
		case CorePackage.ASSOCIATION_END__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CorePackage.ASSOCIATION_END__CONSTRAINT:
			return getConstraint();
		case CorePackage.ASSOCIATION_END__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CorePackage.ASSOCIATION_END__PRESENTATION:
			return getPresentation();
		case CorePackage.ASSOCIATION_END__TARGET_FLOW:
			return getTargetFlow();
		case CorePackage.ASSOCIATION_END__SOURCE_FLOW:
			return getSourceFlow();
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER3:
			return getTemplateParameter3();
		case CorePackage.ASSOCIATION_END__BINDING:
			if (resolve)
				return getBinding();
			return basicGetBinding();
		case CorePackage.ASSOCIATION_END__COMMENT:
			return getComment();
		case CorePackage.ASSOCIATION_END__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER2:
			return getTemplateParameter2();
		case CorePackage.ASSOCIATION_END__STEREOTYPE:
			if (resolve)
				return getStereotype();
			return basicGetStereotype();
		case CorePackage.ASSOCIATION_END__TAGGED_VALUE:
			return getTaggedValue();
		case CorePackage.ASSOCIATION_END__BEHAVIOR:
			return getBehavior();
		case CorePackage.ASSOCIATION_END__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CorePackage.ASSOCIATION_END__COLLABORATION:
			return getCollaboration();
		case CorePackage.ASSOCIATION_END__PARTITION:
			return getPartition();
		case CorePackage.ASSOCIATION_END__IS_NAVIGABLE:
			return isIsNavigable() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.ASSOCIATION_END__ORDERING:
			return getOrdering();
		case CorePackage.ASSOCIATION_END__AGGREGATION:
			return getAggregation();
		case CorePackage.ASSOCIATION_END__TARGET_SCOPE:
			return getTargetScope();
		case CorePackage.ASSOCIATION_END__MULTIPLICITY:
			return getMultiplicity();
		case CorePackage.ASSOCIATION_END__CHANGEABILITY:
			return getChangeability();
		case CorePackage.ASSOCIATION_END__ASSOCIATION:
			return getAssociation();
		case CorePackage.ASSOCIATION_END__QUALIFIER:
			return getQualifier();
		case CorePackage.ASSOCIATION_END__TYPE:
			if (resolve)
				return getType();
			return basicGetType();
		case CorePackage.ASSOCIATION_END__SPECIFICATION:
			return getSpecification();
		case CorePackage.ASSOCIATION_END__LINK_END:
			return getLinkEnd();
		case CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE:
			return getAssociationEndRole();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ASSOCIATION_END__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__NAME:
			setName((String) newValue);
			return;
		case CorePackage.ASSOCIATION_END__VISIBILITY:
			setVisibility((String) newValue);
			return;
		case CorePackage.ASSOCIATION_END__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.ASSOCIATION_END__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CorePackage.ASSOCIATION_END__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			getTemplateParameter3().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__BINDING:
			setBinding((Binding) newValue);
			return;
		case CorePackage.ASSOCIATION_END__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			getTemplateParameter2().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__STEREOTYPE:
			setStereotype((Stereotype) newValue);
			return;
		case CorePackage.ASSOCIATION_END__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__IS_NAVIGABLE:
			setIsNavigable(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.ASSOCIATION_END__ORDERING:
			setOrdering((String) newValue);
			return;
		case CorePackage.ASSOCIATION_END__AGGREGATION:
			setAggregation((String) newValue);
			return;
		case CorePackage.ASSOCIATION_END__TARGET_SCOPE:
			setTargetScope((String) newValue);
			return;
		case CorePackage.ASSOCIATION_END__MULTIPLICITY:
			setMultiplicity((Multiplicity) newValue);
			return;
		case CorePackage.ASSOCIATION_END__CHANGEABILITY:
			setChangeability((String) newValue);
			return;
		case CorePackage.ASSOCIATION_END__ASSOCIATION:
			setAssociation((Association) newValue);
			return;
		case CorePackage.ASSOCIATION_END__QUALIFIER:
			getQualifier().clear();
			getQualifier().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__TYPE:
			setType((Classifier) newValue);
			return;
		case CorePackage.ASSOCIATION_END__SPECIFICATION:
			getSpecification().clear();
			getSpecification().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__LINK_END:
			getLinkEnd().clear();
			getLinkEnd().addAll((Collection) newValue);
			return;
		case CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE:
			getAssociationEndRole().clear();
			getAssociationEndRole().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ASSOCIATION_END__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CorePackage.ASSOCIATION_END__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CorePackage.ASSOCIATION_END__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CorePackage.ASSOCIATION_END__CONSTRAINT:
			getConstraint().clear();
			return;
		case CorePackage.ASSOCIATION_END__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CorePackage.ASSOCIATION_END__PRESENTATION:
			getPresentation().clear();
			return;
		case CorePackage.ASSOCIATION_END__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CorePackage.ASSOCIATION_END__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER3:
			getTemplateParameter3().clear();
			return;
		case CorePackage.ASSOCIATION_END__BINDING:
			setBinding((Binding) null);
			return;
		case CorePackage.ASSOCIATION_END__COMMENT:
			getComment().clear();
			return;
		case CorePackage.ASSOCIATION_END__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER2:
			getTemplateParameter2().clear();
			return;
		case CorePackage.ASSOCIATION_END__STEREOTYPE:
			setStereotype((Stereotype) null);
			return;
		case CorePackage.ASSOCIATION_END__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CorePackage.ASSOCIATION_END__BEHAVIOR:
			getBehavior().clear();
			return;
		case CorePackage.ASSOCIATION_END__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CorePackage.ASSOCIATION_END__COLLABORATION:
			getCollaboration().clear();
			return;
		case CorePackage.ASSOCIATION_END__PARTITION:
			getPartition().clear();
			return;
		case CorePackage.ASSOCIATION_END__IS_NAVIGABLE:
			setIsNavigable(IS_NAVIGABLE_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__ORDERING:
			setOrdering(ORDERING_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__AGGREGATION:
			setAggregation(AGGREGATION_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__TARGET_SCOPE:
			setTargetScope(TARGET_SCOPE_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__MULTIPLICITY:
			setMultiplicity((Multiplicity) null);
			return;
		case CorePackage.ASSOCIATION_END__CHANGEABILITY:
			setChangeability(CHANGEABILITY_EDEFAULT);
			return;
		case CorePackage.ASSOCIATION_END__ASSOCIATION:
			setAssociation((Association) null);
			return;
		case CorePackage.ASSOCIATION_END__QUALIFIER:
			getQualifier().clear();
			return;
		case CorePackage.ASSOCIATION_END__TYPE:
			setType((Classifier) null);
			return;
		case CorePackage.ASSOCIATION_END__SPECIFICATION:
			getSpecification().clear();
			return;
		case CorePackage.ASSOCIATION_END__LINK_END:
			getLinkEnd().clear();
			return;
		case CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE:
			getAssociationEndRole().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ASSOCIATION_END__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CorePackage.ASSOCIATION_END__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CorePackage.ASSOCIATION_END__VISIBILITY:
			return VISIBILITY_EDEFAULT == null ? visibility != null : !VISIBILITY_EDEFAULT.equals(visibility);
		case CorePackage.ASSOCIATION_END__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CorePackage.ASSOCIATION_END__NAMESPACE:
			return getNamespace() != null;
		case CorePackage.ASSOCIATION_END__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CorePackage.ASSOCIATION_END__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CorePackage.ASSOCIATION_END__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CorePackage.ASSOCIATION_END__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CorePackage.ASSOCIATION_END__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CorePackage.ASSOCIATION_END__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER3:
			return templateParameter3 != null && !templateParameter3.isEmpty();
		case CorePackage.ASSOCIATION_END__BINDING:
			return binding != null;
		case CorePackage.ASSOCIATION_END__COMMENT:
			return comment != null && !comment.isEmpty();
		case CorePackage.ASSOCIATION_END__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CorePackage.ASSOCIATION_END__TEMPLATE_PARAMETER2:
			return templateParameter2 != null && !templateParameter2.isEmpty();
		case CorePackage.ASSOCIATION_END__STEREOTYPE:
			return stereotype != null;
		case CorePackage.ASSOCIATION_END__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CorePackage.ASSOCIATION_END__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CorePackage.ASSOCIATION_END__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CorePackage.ASSOCIATION_END__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CorePackage.ASSOCIATION_END__PARTITION:
			return partition != null && !partition.isEmpty();
		case CorePackage.ASSOCIATION_END__IS_NAVIGABLE:
			return isNavigable != IS_NAVIGABLE_EDEFAULT;
		case CorePackage.ASSOCIATION_END__ORDERING:
			return ORDERING_EDEFAULT == null ? ordering != null : !ORDERING_EDEFAULT.equals(ordering);
		case CorePackage.ASSOCIATION_END__AGGREGATION:
			return AGGREGATION_EDEFAULT == null ? aggregation != null : !AGGREGATION_EDEFAULT.equals(aggregation);
		case CorePackage.ASSOCIATION_END__TARGET_SCOPE:
			return TARGET_SCOPE_EDEFAULT == null ? targetScope != null : !TARGET_SCOPE_EDEFAULT.equals(targetScope);
		case CorePackage.ASSOCIATION_END__MULTIPLICITY:
			return multiplicity != null;
		case CorePackage.ASSOCIATION_END__CHANGEABILITY:
			return CHANGEABILITY_EDEFAULT == null ? changeability != null : !CHANGEABILITY_EDEFAULT.equals(changeability);
		case CorePackage.ASSOCIATION_END__ASSOCIATION:
			return getAssociation() != null;
		case CorePackage.ASSOCIATION_END__QUALIFIER:
			return qualifier != null && !qualifier.isEmpty();
		case CorePackage.ASSOCIATION_END__TYPE:
			return type != null;
		case CorePackage.ASSOCIATION_END__SPECIFICATION:
			return specification != null && !specification.isEmpty();
		case CorePackage.ASSOCIATION_END__LINK_END:
			return linkEnd != null && !linkEnd.isEmpty();
		case CorePackage.ASSOCIATION_END__ASSOCIATION_END_ROLE:
			return associationEndRole != null && !associationEndRole.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String toString() {
		if (eIsProxy())
			return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (isNavigable: "); //$NON-NLS-1$
		result.append(isNavigable);
		result.append(", ordering: "); //$NON-NLS-1$
		result.append(ordering);
		result.append(", aggregation: "); //$NON-NLS-1$
		result.append(aggregation);
		result.append(", targetScope: "); //$NON-NLS-1$
		result.append(targetScope);
		result.append(", changeability: "); //$NON-NLS-1$
		result.append(changeability);
		result.append(')');
		return result.toString();
	}

} // AssociationEndImpl
