/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ClassifierImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Classifier Role</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getMultiplicity
 * <em>Multiplicity</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getMessage
 * <em>Message</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getAvailableContents
 * <em>Available Contents</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.ClassifierRoleImpl#getConformingInstance
 * <em>Conforming Instance</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ClassifierRoleImpl extends ClassifierImpl implements ClassifierRole {
	/**
	 * The cached value of the '{@link #getMultiplicity() <em>Multiplicity</em>}
	 * ' containment reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMultiplicity()
	 * @generated
	 * @ordered
	 */
	protected Multiplicity multiplicity = null;

	/**
	 * The cached value of the '{@link #getMessage() <em>Message</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMessage()
	 * @generated
	 * @ordered
	 */
	protected EList message = null;

	/**
	 * The cached value of the '{@link #getAvailableContents()
	 * <em>Available Contents</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getAvailableContents()
	 * @generated
	 * @ordered
	 */
	protected EList availableContents = null;

	/**
	 * The cached value of the '{@link #getConformingInstance()
	 * <em>Conforming Instance</em>}' reference list. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @see #getConformingInstance()
	 * @generated
	 * @ordered
	 */
	protected EList conformingInstance = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ClassifierRoleImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CollaborationsPackage.eINSTANCE.getClassifierRole();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Multiplicity getMultiplicity() {
		return multiplicity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetMultiplicity(Multiplicity newMultiplicity, NotificationChain msgs) {
		Multiplicity oldMultiplicity = multiplicity;
		multiplicity = newMultiplicity;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, oldMultiplicity, newMultiplicity);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setMultiplicity(Multiplicity newMultiplicity) {
		if (newMultiplicity != multiplicity) {
			NotificationChain msgs = null;
			if (multiplicity != null)
				msgs = ((InternalEObject) multiplicity).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, null, msgs);
			if (newMultiplicity != null)
				msgs = ((InternalEObject) newMultiplicity).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, null, msgs);
			msgs = basicSetMultiplicity(newMultiplicity, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY, newMultiplicity, newMultiplicity));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getMessage() {
		if (message == null) {
			message = new EObjectWithInverseResolvingEList(Message.class, this, CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE, CollaborationsPackage.MESSAGE__SENDER);
		}
		return message;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAvailableContents() {
		if (availableContents == null) {
			availableContents = new EObjectWithInverseResolvingEList.ManyInverse(ModelElement.class, this, CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS,
					CorePackage.MODEL_ELEMENT__CLASSIFIER_ROLE);
		}
		return availableContents;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getConformingInstance() {
		if (conformingInstance == null) {
			conformingInstance = new EObjectWithInverseResolvingEList.ManyInverse(Instance.class, this, CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE,
					Common_behaviorPackage.INSTANCE__PLAYED_ROLE);
		}
		return conformingInstance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
				return ((InternalEList) getFeature()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_FEATURE:
				return ((InternalEList) getTypedFeature()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_PARAMETER:
				return ((InternalEList) getTypedParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ASSOCIATION:
				return ((InternalEList) getAssociation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SPECIFIED_END:
				return ((InternalEList) getSpecifiedEnd()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
				return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE:
				return ((InternalEList) getMessage()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
				return ((InternalEList) getAvailableContents()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE:
				return ((InternalEList) getConformingInstance()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
				return eBasicSetContainer(null, CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
				return ((InternalEList) getFeature()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_FEATURE:
				return ((InternalEList) getTypedFeature()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_PARAMETER:
				return ((InternalEList) getTypedParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__ASSOCIATION:
				return ((InternalEList) getAssociation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__SPECIFIED_END:
				return ((InternalEList) getSpecifiedEnd()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
				return ((InternalEList) getInstance()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
				return basicSetMultiplicity(null, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE:
				return ((InternalEList) getMessage()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
				return ((InternalEList) getAvailableContents()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE:
				return ((InternalEList) getConformingInstance()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			return getName();
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			return getVisibility();
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			return getNamespace();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			return getConstraint();
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			return getPresentation();
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			return getTargetFlow();
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			return getSourceFlow();
		case CollaborationsPackage.CLASSIFIER_ROLE__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			return getComment();
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			return getStereotype();
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			return getTaggedValue();
		case CollaborationsPackage.CLASSIFIER_ROLE__REFERENCE_TAG:
			return getReferenceTag();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			return getBehavior();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			return getCollaboration();
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			return getPartition();
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			return getElementImport();
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			return getGeneralization();
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			return getSpecialization();
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			return getOwnedElement();
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			return getFeature();
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_FEATURE:
			return getTypedFeature();
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_PARAMETER:
			return getTypedParameter();
		case CollaborationsPackage.CLASSIFIER_ROLE__ASSOCIATION:
			return getAssociation();
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIFIED_END:
			return getSpecifiedEnd();
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			return getPowertypeRange();
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			return getInstance();
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			return getCreateAction();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			return getObjectFlowState();
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			return getMultiplicity();
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE:
			return getMessage();
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			return getAvailableContents();
		case CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE:
			return getConformingInstance();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			setName((String) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			getOwnedElement().clear();
			getOwnedElement().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			getFeature().clear();
			getFeature().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_FEATURE:
			getTypedFeature().clear();
			getTypedFeature().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_PARAMETER:
			getTypedParameter().clear();
			getTypedParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ASSOCIATION:
			getAssociation().clear();
			getAssociation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIFIED_END:
			getSpecifiedEnd().clear();
			getSpecifiedEnd().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			getPowertypeRange().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			getInstance().clear();
			getInstance().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			getCreateAction().clear();
			getCreateAction().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			getObjectFlowState().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			setMultiplicity((Multiplicity) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE:
			getMessage().clear();
			getMessage().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			getAvailableContents().clear();
			getAvailableContents().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE:
			getConformingInstance().clear();
			getConformingInstance().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			getConstraint().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			getPresentation().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			getComment().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			getStereotype().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			getBehavior().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			getCollaboration().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			getPartition().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			getGeneralization().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			getOwnedElement().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			getFeature().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_FEATURE:
			getTypedFeature().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_PARAMETER:
			getTypedParameter().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__ASSOCIATION:
			getAssociation().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIFIED_END:
			getSpecifiedEnd().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			getInstance().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			getCreateAction().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			setMultiplicity((Multiplicity) null);
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE:
			getMessage().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			getAvailableContents().clear();
			return;
		case CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE:
			getConformingInstance().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.CLASSIFIER_ROLE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CollaborationsPackage.CLASSIFIER_ROLE__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__NAMESPACE:
			return getNamespace() != null;
		case CollaborationsPackage.CLASSIFIER_ROLE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__COMMENT:
			return comment != null && !comment.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CollaborationsPackage.CLASSIFIER_ROLE__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__PARTITION:
			return partition != null && !partition.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case CollaborationsPackage.CLASSIFIER_ROLE__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__OWNED_ELEMENT:
			return ownedElement != null && !ownedElement.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__FEATURE:
			return feature != null && !feature.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_FEATURE:
			return typedFeature != null && !typedFeature.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__TYPED_PARAMETER:
			return typedParameter != null && !typedParameter.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__ASSOCIATION:
			return association != null && !association.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__SPECIFIED_END:
			return specifiedEnd != null && !specifiedEnd.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__POWERTYPE_RANGE:
			return powertypeRange != null && !powertypeRange.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__INSTANCE:
			return instance != null && !instance.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CREATE_ACTION:
			return createAction != null && !createAction.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__OBJECT_FLOW_STATE:
			return objectFlowState != null && !objectFlowState.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__MULTIPLICITY:
			return multiplicity != null;
		case CollaborationsPackage.CLASSIFIER_ROLE__MESSAGE:
			return message != null && !message.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__AVAILABLE_CONTENTS:
			return availableContents != null && !availableContents.isEmpty();
		case CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE:
			return conformingInstance != null && !conformingInstance.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // ClassifierRoleImpl
