/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Collaboration;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Interaction;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.InteractionInstanceSet;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Interaction</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.InteractionImpl#getMessage
 * <em>Message</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.InteractionImpl#getContext
 * <em>Context</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.InteractionImpl#getInteractionInstanceSet
 * <em>Interaction Instance Set</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class InteractionImpl extends ModelElementImpl implements Interaction {
	/**
	 * The cached value of the '{@link #getMessage() <em>Message</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getMessage()
	 * @generated
	 * @ordered
	 */
	protected EList message = null;

	/**
	 * The cached value of the '{@link #getInteractionInstanceSet()
	 * <em>Interaction Instance Set</em>}' reference list. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getInteractionInstanceSet()
	 * @generated
	 * @ordered
	 */
	protected EList interactionInstanceSet = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InteractionImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CollaborationsPackage.eINSTANCE.getInteraction();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getMessage() {
		if (message == null) {
			message = new EObjectContainmentWithInverseEList(Message.class, this, CollaborationsPackage.INTERACTION__MESSAGE, CollaborationsPackage.MESSAGE__INTERACTION);
		}
		return message;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Collaboration getContext() {
		if (eContainerFeatureID != CollaborationsPackage.INTERACTION__CONTEXT)
			return null;
		return (Collaboration) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setContext(Collaboration newContext) {
		if (newContext != eContainer || (eContainerFeatureID != CollaborationsPackage.INTERACTION__CONTEXT && newContext != null)) {
			if (EcoreUtil.isAncestor(this, newContext))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newContext != null)
				msgs = ((InternalEObject) newContext).eInverseAdd(this, CollaborationsPackage.COLLABORATION__INTERACTION, Collaboration.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newContext, CollaborationsPackage.INTERACTION__CONTEXT, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, CollaborationsPackage.INTERACTION__CONTEXT, newContext, newContext));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getInteractionInstanceSet() {
		if (interactionInstanceSet == null) {
			interactionInstanceSet = new EObjectWithInverseResolvingEList(InteractionInstanceSet.class, this, CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET,
					CollaborationsPackage.INTERACTION_INSTANCE_SET__INTERACTION);
		}
		return interactionInstanceSet;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.INTERACTION__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.INTERACTION__NAMESPACE, msgs);
			case CollaborationsPackage.INTERACTION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.INTERACTION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__MESSAGE:
				return ((InternalEList) getMessage()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__CONTEXT:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.INTERACTION__CONTEXT, msgs);
			case CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET:
				return ((InternalEList) getInteractionInstanceSet()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.INTERACTION__NAMESPACE:
				return eBasicSetContainer(null, CollaborationsPackage.INTERACTION__NAMESPACE, msgs);
			case CollaborationsPackage.INTERACTION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.INTERACTION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__MESSAGE:
				return ((InternalEList) getMessage()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.INTERACTION__CONTEXT:
				return eBasicSetContainer(null, CollaborationsPackage.INTERACTION__CONTEXT, msgs);
			case CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET:
				return ((InternalEList) getInteractionInstanceSet()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CollaborationsPackage.INTERACTION__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case CollaborationsPackage.INTERACTION__CONTEXT:
				return eContainer.eInverseRemove(this, CollaborationsPackage.COLLABORATION__INTERACTION, Collaboration.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION__NAME:
			return getName();
		case CollaborationsPackage.INTERACTION__VISIBILITY:
			return getVisibility();
		case CollaborationsPackage.INTERACTION__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.INTERACTION__NAMESPACE:
			return getNamespace();
		case CollaborationsPackage.INTERACTION__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CollaborationsPackage.INTERACTION__CONSTRAINT:
			return getConstraint();
		case CollaborationsPackage.INTERACTION__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CollaborationsPackage.INTERACTION__PRESENTATION:
			return getPresentation();
		case CollaborationsPackage.INTERACTION__TARGET_FLOW:
			return getTargetFlow();
		case CollaborationsPackage.INTERACTION__SOURCE_FLOW:
			return getSourceFlow();
		case CollaborationsPackage.INTERACTION__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CollaborationsPackage.INTERACTION__COMMENT:
			return getComment();
		case CollaborationsPackage.INTERACTION__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CollaborationsPackage.INTERACTION__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CollaborationsPackage.INTERACTION__STEREOTYPE:
			return getStereotype();
		case CollaborationsPackage.INTERACTION__TAGGED_VALUE:
			return getTaggedValue();
		case CollaborationsPackage.INTERACTION__REFERENCE_TAG:
			return getReferenceTag();
		case CollaborationsPackage.INTERACTION__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CollaborationsPackage.INTERACTION__BEHAVIOR:
			return getBehavior();
		case CollaborationsPackage.INTERACTION__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CollaborationsPackage.INTERACTION__COLLABORATION:
			return getCollaboration();
		case CollaborationsPackage.INTERACTION__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CollaborationsPackage.INTERACTION__PARTITION:
			return getPartition();
		case CollaborationsPackage.INTERACTION__ELEMENT_IMPORT:
			return getElementImport();
		case CollaborationsPackage.INTERACTION__MESSAGE:
			return getMessage();
		case CollaborationsPackage.INTERACTION__CONTEXT:
			return getContext();
		case CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET:
			return getInteractionInstanceSet();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION__NAME:
			setName((String) newValue);
			return;
		case CollaborationsPackage.INTERACTION__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CollaborationsPackage.INTERACTION__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.INTERACTION__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CollaborationsPackage.INTERACTION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CollaborationsPackage.INTERACTION__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__MESSAGE:
			getMessage().clear();
			getMessage().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.INTERACTION__CONTEXT:
			setContext((Collaboration) newValue);
			return;
		case CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET:
			getInteractionInstanceSet().clear();
			getInteractionInstanceSet().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CollaborationsPackage.INTERACTION__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CollaborationsPackage.INTERACTION__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CollaborationsPackage.INTERACTION__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CollaborationsPackage.INTERACTION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CollaborationsPackage.INTERACTION__CONSTRAINT:
			getConstraint().clear();
			return;
		case CollaborationsPackage.INTERACTION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CollaborationsPackage.INTERACTION__PRESENTATION:
			getPresentation().clear();
			return;
		case CollaborationsPackage.INTERACTION__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CollaborationsPackage.INTERACTION__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CollaborationsPackage.INTERACTION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CollaborationsPackage.INTERACTION__COMMENT:
			getComment().clear();
			return;
		case CollaborationsPackage.INTERACTION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CollaborationsPackage.INTERACTION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CollaborationsPackage.INTERACTION__STEREOTYPE:
			getStereotype().clear();
			return;
		case CollaborationsPackage.INTERACTION__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CollaborationsPackage.INTERACTION__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CollaborationsPackage.INTERACTION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CollaborationsPackage.INTERACTION__BEHAVIOR:
			getBehavior().clear();
			return;
		case CollaborationsPackage.INTERACTION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CollaborationsPackage.INTERACTION__COLLABORATION:
			getCollaboration().clear();
			return;
		case CollaborationsPackage.INTERACTION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CollaborationsPackage.INTERACTION__PARTITION:
			getPartition().clear();
			return;
		case CollaborationsPackage.INTERACTION__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CollaborationsPackage.INTERACTION__MESSAGE:
			getMessage().clear();
			return;
		case CollaborationsPackage.INTERACTION__CONTEXT:
			setContext((Collaboration) null);
			return;
		case CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET:
			getInteractionInstanceSet().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.INTERACTION__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CollaborationsPackage.INTERACTION__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CollaborationsPackage.INTERACTION__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CollaborationsPackage.INTERACTION__NAMESPACE:
			return getNamespace() != null;
		case CollaborationsPackage.INTERACTION__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CollaborationsPackage.INTERACTION__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CollaborationsPackage.INTERACTION__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CollaborationsPackage.INTERACTION__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CollaborationsPackage.INTERACTION__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CollaborationsPackage.INTERACTION__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CollaborationsPackage.INTERACTION__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CollaborationsPackage.INTERACTION__COMMENT:
			return comment != null && !comment.isEmpty();
		case CollaborationsPackage.INTERACTION__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CollaborationsPackage.INTERACTION__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CollaborationsPackage.INTERACTION__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CollaborationsPackage.INTERACTION__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CollaborationsPackage.INTERACTION__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CollaborationsPackage.INTERACTION__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CollaborationsPackage.INTERACTION__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CollaborationsPackage.INTERACTION__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CollaborationsPackage.INTERACTION__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CollaborationsPackage.INTERACTION__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CollaborationsPackage.INTERACTION__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CollaborationsPackage.INTERACTION__PARTITION:
			return partition != null && !partition.isEmpty();
		case CollaborationsPackage.INTERACTION__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CollaborationsPackage.INTERACTION__MESSAGE:
			return message != null && !message.isEmpty();
		case CollaborationsPackage.INTERACTION__CONTEXT:
			return getContext() != null;
		case CollaborationsPackage.INTERACTION__INTERACTION_INSTANCE_SET:
			return interactionInstanceSet != null && !interactionInstanceSet.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // InteractionImpl
