/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.ClassifierRole;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.AttributeLink;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.ComponentInstance;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Link;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.LinkEnd;
import fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus;
import fr.obeo.acceleo.uml14.foundation.core.Classifier;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Instance</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getClassifier
 * <em>Classifier</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getAttributeLink
 * <em>Attribute Link</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getLinkEnd
 * <em>Link End</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getSlot
 * <em>Slot</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getStimulus
 * <em>Stimulus</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getComponentInstance
 * <em>Component Instance</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getOwnedInstance
 * <em>Owned Instance</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getOwner
 * <em>Owner</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getOwnedLink
 * <em>Owned Link</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.impl.InstanceImpl#getPlayedRole
 * <em>Played Role</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public abstract class InstanceImpl extends ModelElementImpl implements Instance {
	/**
	 * The cached value of the '{@link #getClassifier() <em>Classifier</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getClassifier()
	 * @generated
	 * @ordered
	 */
	protected EList classifier = null;

	/**
	 * The cached value of the '{@link #getAttributeLink()
	 * <em>Attribute Link</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getAttributeLink()
	 * @generated
	 * @ordered
	 */
	protected EList attributeLink = null;

	/**
	 * The cached value of the '{@link #getLinkEnd() <em>Link End</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getLinkEnd()
	 * @generated
	 * @ordered
	 */
	protected EList linkEnd = null;

	/**
	 * The cached value of the '{@link #getSlot() <em>Slot</em>}' containment
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getSlot()
	 * @generated
	 * @ordered
	 */
	protected EList slot = null;

	/**
	 * The cached value of the '{@link #getStimulus() <em>Stimulus</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getStimulus()
	 * @generated
	 * @ordered
	 */
	protected EList stimulus = null;

	/**
	 * The cached value of the '{@link #getComponentInstance()
	 * <em>Component Instance</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getComponentInstance()
	 * @generated
	 * @ordered
	 */
	protected ComponentInstance componentInstance = null;

	/**
	 * The cached value of the '{@link #getOwnedInstance()
	 * <em>Owned Instance</em>}' containment reference list. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getOwnedInstance()
	 * @generated
	 * @ordered
	 */
	protected EList ownedInstance = null;

	/**
	 * The cached value of the '{@link #getOwnedLink() <em>Owned Link</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOwnedLink()
	 * @generated
	 * @ordered
	 */
	protected EList ownedLink = null;

	/**
	 * The cached value of the '{@link #getPlayedRole() <em>Played Role</em>}'
	 * reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getPlayedRole()
	 * @generated
	 * @ordered
	 */
	protected EList playedRole = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected InstanceImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return Common_behaviorPackage.eINSTANCE.getInstance();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getClassifier() {
		if (classifier == null) {
			classifier = new EObjectWithInverseResolvingEList.ManyInverse(Classifier.class, this, Common_behaviorPackage.INSTANCE__CLASSIFIER, CorePackage.CLASSIFIER__INSTANCE);
		}
		return classifier;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getAttributeLink() {
		if (attributeLink == null) {
			attributeLink = new EObjectWithInverseResolvingEList(AttributeLink.class, this, Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK, Common_behaviorPackage.ATTRIBUTE_LINK__VALUE);
		}
		return attributeLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getLinkEnd() {
		if (linkEnd == null) {
			linkEnd = new EObjectWithInverseResolvingEList(LinkEnd.class, this, Common_behaviorPackage.INSTANCE__LINK_END, Common_behaviorPackage.LINK_END__INSTANCE);
		}
		return linkEnd;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSlot() {
		if (slot == null) {
			slot = new EObjectContainmentWithInverseEList(AttributeLink.class, this, Common_behaviorPackage.INSTANCE__SLOT, Common_behaviorPackage.ATTRIBUTE_LINK__INSTANCE);
		}
		return slot;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getStimulus() {
		if (stimulus == null) {
			stimulus = new EObjectWithInverseResolvingEList.ManyInverse(Stimulus.class, this, Common_behaviorPackage.INSTANCE__STIMULUS, Common_behaviorPackage.STIMULUS__ARGUMENT);
		}
		return stimulus;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ComponentInstance getComponentInstance() {
		if (componentInstance != null && componentInstance.eIsProxy()) {
			ComponentInstance oldComponentInstance = componentInstance;
			componentInstance = (ComponentInstance) eResolveProxy((InternalEObject) componentInstance);
			if (componentInstance != oldComponentInstance) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE, oldComponentInstance, componentInstance));
			}
		}
		return componentInstance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ComponentInstance basicGetComponentInstance() {
		return componentInstance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetComponentInstance(ComponentInstance newComponentInstance, NotificationChain msgs) {
		ComponentInstance oldComponentInstance = componentInstance;
		componentInstance = newComponentInstance;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE, oldComponentInstance, newComponentInstance);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setComponentInstance(ComponentInstance newComponentInstance) {
		if (newComponentInstance != componentInstance) {
			NotificationChain msgs = null;
			if (componentInstance != null)
				msgs = ((InternalEObject) componentInstance).eInverseRemove(this, Common_behaviorPackage.COMPONENT_INSTANCE__RESIDENT, ComponentInstance.class, msgs);
			if (newComponentInstance != null)
				msgs = ((InternalEObject) newComponentInstance).eInverseAdd(this, Common_behaviorPackage.COMPONENT_INSTANCE__RESIDENT, ComponentInstance.class, msgs);
			msgs = basicSetComponentInstance(newComponentInstance, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE, newComponentInstance, newComponentInstance));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getOwnedInstance() {
		if (ownedInstance == null) {
			ownedInstance = new EObjectContainmentWithInverseEList(Instance.class, this, Common_behaviorPackage.INSTANCE__OWNED_INSTANCE, Common_behaviorPackage.INSTANCE__OWNER);
		}
		return ownedInstance;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Instance getOwner() {
		if (eContainerFeatureID != Common_behaviorPackage.INSTANCE__OWNER)
			return null;
		return (Instance) eContainer;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setOwner(Instance newOwner) {
		if (newOwner != eContainer || (eContainerFeatureID != Common_behaviorPackage.INSTANCE__OWNER && newOwner != null)) {
			if (EcoreUtil.isAncestor(this, newOwner))
				throw new IllegalArgumentException("Recursive containment not allowed for " + toString()); //$NON-NLS-1$
			NotificationChain msgs = null;
			if (eContainer != null)
				msgs = eBasicRemoveFromContainer(msgs);
			if (newOwner != null)
				msgs = ((InternalEObject) newOwner).eInverseAdd(this, Common_behaviorPackage.INSTANCE__OWNED_INSTANCE, Instance.class, msgs);
			msgs = eBasicSetContainer((InternalEObject) newOwner, Common_behaviorPackage.INSTANCE__OWNER, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, Common_behaviorPackage.INSTANCE__OWNER, newOwner, newOwner));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getOwnedLink() {
		if (ownedLink == null) {
			ownedLink = new EObjectContainmentWithInverseEList(Link.class, this, Common_behaviorPackage.INSTANCE__OWNED_LINK, Common_behaviorPackage.LINK__OWNER);
		}
		return ownedLink;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getPlayedRole() {
		if (playedRole == null) {
			playedRole = new EObjectWithInverseResolvingEList.ManyInverse(ClassifierRole.class, this, Common_behaviorPackage.INSTANCE__PLAYED_ROLE,
					CollaborationsPackage.CLASSIFIER_ROLE__CONFORMING_INSTANCE);
		}
		return playedRole;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.INSTANCE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.INSTANCE__NAMESPACE, msgs);
			case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.INSTANCE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER:
				return ((InternalEList) getClassifier()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
				return ((InternalEList) getAttributeLink()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__LINK_END:
				return ((InternalEList) getLinkEnd()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SLOT:
				return ((InternalEList) getSlot()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS:
				return ((InternalEList) getStimulus()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
				if (componentInstance != null)
					msgs = ((InternalEObject) componentInstance).eInverseRemove(this, Common_behaviorPackage.COMPONENT_INSTANCE__RESIDENT, ComponentInstance.class, msgs);
				return basicSetComponentInstance((ComponentInstance) otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__OWNED_INSTANCE:
				return ((InternalEList) getOwnedInstance()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__OWNER:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, Common_behaviorPackage.INSTANCE__OWNER, msgs);
			case Common_behaviorPackage.INSTANCE__OWNED_LINK:
				return ((InternalEList) getOwnedLink()).basicAdd(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PLAYED_ROLE:
				return ((InternalEList) getPlayedRole()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case Common_behaviorPackage.INSTANCE__NAMESPACE:
				return eBasicSetContainer(null, Common_behaviorPackage.INSTANCE__NAMESPACE, msgs);
			case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE, msgs);
			case Common_behaviorPackage.INSTANCE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__CLASSIFIER:
				return ((InternalEList) getClassifier()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
				return ((InternalEList) getAttributeLink()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__LINK_END:
				return ((InternalEList) getLinkEnd()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__SLOT:
				return ((InternalEList) getSlot()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__STIMULUS:
				return ((InternalEList) getStimulus()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
				return basicSetComponentInstance(null, msgs);
			case Common_behaviorPackage.INSTANCE__OWNED_INSTANCE:
				return ((InternalEList) getOwnedInstance()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__OWNER:
				return eBasicSetContainer(null, Common_behaviorPackage.INSTANCE__OWNER, msgs);
			case Common_behaviorPackage.INSTANCE__OWNED_LINK:
				return ((InternalEList) getOwnedLink()).basicRemove(otherEnd, msgs);
			case Common_behaviorPackage.INSTANCE__PLAYED_ROLE:
				return ((InternalEList) getPlayedRole()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case Common_behaviorPackage.INSTANCE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			case Common_behaviorPackage.INSTANCE__OWNER:
				return eContainer.eInverseRemove(this, Common_behaviorPackage.INSTANCE__OWNED_INSTANCE, Instance.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__NAME:
			return getName();
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			return getVisibility();
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			return getNamespace();
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			return getConstraint();
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			return getPresentation();
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			return getTargetFlow();
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			return getSourceFlow();
		case Common_behaviorPackage.INSTANCE__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case Common_behaviorPackage.INSTANCE__COMMENT:
			return getComment();
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			return getStereotype();
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			return getTaggedValue();
		case Common_behaviorPackage.INSTANCE__REFERENCE_TAG:
			return getReferenceTag();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			return getBehavior();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			return getCollaboration();
		case Common_behaviorPackage.INSTANCE__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case Common_behaviorPackage.INSTANCE__PARTITION:
			return getPartition();
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			return getElementImport();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			return getClassifier();
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			return getAttributeLink();
		case Common_behaviorPackage.INSTANCE__LINK_END:
			return getLinkEnd();
		case Common_behaviorPackage.INSTANCE__SLOT:
			return getSlot();
		case Common_behaviorPackage.INSTANCE__STIMULUS:
			return getStimulus();
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			if (resolve)
				return getComponentInstance();
			return basicGetComponentInstance();
		case Common_behaviorPackage.INSTANCE__OWNED_INSTANCE:
			return getOwnedInstance();
		case Common_behaviorPackage.INSTANCE__OWNER:
			return getOwner();
		case Common_behaviorPackage.INSTANCE__OWNED_LINK:
			return getOwnedLink();
		case Common_behaviorPackage.INSTANCE__PLAYED_ROLE:
			return getPlayedRole();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__NAME:
			setName((String) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			getClassifier().clear();
			getClassifier().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			getAttributeLink().clear();
			getAttributeLink().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__LINK_END:
			getLinkEnd().clear();
			getLinkEnd().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__SLOT:
			getSlot().clear();
			getSlot().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS:
			getStimulus().clear();
			getStimulus().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			setComponentInstance((ComponentInstance) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__OWNED_INSTANCE:
			getOwnedInstance().clear();
			getOwnedInstance().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__OWNER:
			setOwner((Instance) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__OWNED_LINK:
			getOwnedLink().clear();
			getOwnedLink().addAll((Collection) newValue);
			return;
		case Common_behaviorPackage.INSTANCE__PLAYED_ROLE:
			getPlayedRole().clear();
			getPlayedRole().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			getConstraint().clear();
			return;
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			getPresentation().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case Common_behaviorPackage.INSTANCE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case Common_behaviorPackage.INSTANCE__COMMENT:
			getComment().clear();
			return;
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			getStereotype().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case Common_behaviorPackage.INSTANCE__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case Common_behaviorPackage.INSTANCE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			getBehavior().clear();
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			getCollaboration().clear();
			return;
		case Common_behaviorPackage.INSTANCE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case Common_behaviorPackage.INSTANCE__PARTITION:
			getPartition().clear();
			return;
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			getClassifier().clear();
			return;
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			getAttributeLink().clear();
			return;
		case Common_behaviorPackage.INSTANCE__LINK_END:
			getLinkEnd().clear();
			return;
		case Common_behaviorPackage.INSTANCE__SLOT:
			getSlot().clear();
			return;
		case Common_behaviorPackage.INSTANCE__STIMULUS:
			getStimulus().clear();
			return;
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			setComponentInstance((ComponentInstance) null);
			return;
		case Common_behaviorPackage.INSTANCE__OWNED_INSTANCE:
			getOwnedInstance().clear();
			return;
		case Common_behaviorPackage.INSTANCE__OWNER:
			setOwner((Instance) null);
			return;
		case Common_behaviorPackage.INSTANCE__OWNED_LINK:
			getOwnedLink().clear();
			return;
		case Common_behaviorPackage.INSTANCE__PLAYED_ROLE:
			getPlayedRole().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case Common_behaviorPackage.INSTANCE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case Common_behaviorPackage.INSTANCE__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case Common_behaviorPackage.INSTANCE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case Common_behaviorPackage.INSTANCE__NAMESPACE:
			return getNamespace() != null;
		case Common_behaviorPackage.INSTANCE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case Common_behaviorPackage.INSTANCE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case Common_behaviorPackage.INSTANCE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case Common_behaviorPackage.INSTANCE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case Common_behaviorPackage.INSTANCE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case Common_behaviorPackage.INSTANCE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case Common_behaviorPackage.INSTANCE__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case Common_behaviorPackage.INSTANCE__COMMENT:
			return comment != null && !comment.isEmpty();
		case Common_behaviorPackage.INSTANCE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case Common_behaviorPackage.INSTANCE__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case Common_behaviorPackage.INSTANCE__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case Common_behaviorPackage.INSTANCE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case Common_behaviorPackage.INSTANCE__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case Common_behaviorPackage.INSTANCE__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case Common_behaviorPackage.INSTANCE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case Common_behaviorPackage.INSTANCE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case Common_behaviorPackage.INSTANCE__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case Common_behaviorPackage.INSTANCE__PARTITION:
			return partition != null && !partition.isEmpty();
		case Common_behaviorPackage.INSTANCE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case Common_behaviorPackage.INSTANCE__CLASSIFIER:
			return classifier != null && !classifier.isEmpty();
		case Common_behaviorPackage.INSTANCE__ATTRIBUTE_LINK:
			return attributeLink != null && !attributeLink.isEmpty();
		case Common_behaviorPackage.INSTANCE__LINK_END:
			return linkEnd != null && !linkEnd.isEmpty();
		case Common_behaviorPackage.INSTANCE__SLOT:
			return slot != null && !slot.isEmpty();
		case Common_behaviorPackage.INSTANCE__STIMULUS:
			return stimulus != null && !stimulus.isEmpty();
		case Common_behaviorPackage.INSTANCE__COMPONENT_INSTANCE:
			return componentInstance != null;
		case Common_behaviorPackage.INSTANCE__OWNED_INSTANCE:
			return ownedInstance != null && !ownedInstance.isEmpty();
		case Common_behaviorPackage.INSTANCE__OWNER:
			return getOwner() != null;
		case Common_behaviorPackage.INSTANCE__OWNED_LINK:
			return ownedLink != null && !ownedLink.isEmpty();
		case Common_behaviorPackage.INSTANCE__PLAYED_ROLE:
			return playedRole != null && !playedRole.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // InstanceImpl
