/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.state_machines.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.StateMachine;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.State_machinesPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.SubmachineState;
import fr.obeo.acceleo.uml14.behavioral_elements.state_machines.Transition;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.ModelElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>State Machine</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.impl.StateMachineImpl#getContext
 * <em>Context</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.impl.StateMachineImpl#getTop
 * <em>Top</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.impl.StateMachineImpl#getTransitions
 * <em>Transitions</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.state_machines.impl.StateMachineImpl#getSubmachineState
 * <em>Submachine State</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class StateMachineImpl extends ModelElementImpl implements StateMachine {
	/**
	 * The cached value of the '{@link #getContext() <em>Context</em>}'
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getContext()
	 * @generated
	 * @ordered
	 */
	protected ModelElement context = null;

	/**
	 * The cached value of the '{@link #getTop() <em>Top</em>}' containment
	 * reference. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTop()
	 * @generated
	 * @ordered
	 */
	protected State top = null;

	/**
	 * The cached value of the '{@link #getTransitions() <em>Transitions</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getTransitions()
	 * @generated
	 * @ordered
	 */
	protected EList transitions = null;

	/**
	 * The cached value of the '{@link #getSubmachineState()
	 * <em>Submachine State</em>}' reference list. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @see #getSubmachineState()
	 * @generated
	 * @ordered
	 */
	protected EList submachineState = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected StateMachineImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return State_machinesPackage.eINSTANCE.getStateMachine();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ModelElement getContext() {
		if (context != null && context.eIsProxy()) {
			ModelElement oldContext = context;
			context = (ModelElement) eResolveProxy((InternalEObject) context);
			if (context != oldContext) {
				if (eNotificationRequired())
					eNotify(new ENotificationImpl(this, Notification.RESOLVE, State_machinesPackage.STATE_MACHINE__CONTEXT, oldContext, context));
			}
		}
		return context;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ModelElement basicGetContext() {
		return context;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetContext(ModelElement newContext, NotificationChain msgs) {
		ModelElement oldContext = context;
		context = newContext;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE_MACHINE__CONTEXT, oldContext, newContext);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setContext(ModelElement newContext) {
		if (newContext != context) {
			NotificationChain msgs = null;
			if (context != null)
				msgs = ((InternalEObject) context).eInverseRemove(this, CorePackage.MODEL_ELEMENT__BEHAVIOR, ModelElement.class, msgs);
			if (newContext != null)
				msgs = ((InternalEObject) newContext).eInverseAdd(this, CorePackage.MODEL_ELEMENT__BEHAVIOR, ModelElement.class, msgs);
			msgs = basicSetContext(newContext, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE_MACHINE__CONTEXT, newContext, newContext));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public State getTop() {
		return top;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain basicSetTop(State newTop, NotificationChain msgs) {
		State oldTop = top;
		top = newTop;
		if (eNotificationRequired()) {
			ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE_MACHINE__TOP, oldTop, newTop);
			if (msgs == null)
				msgs = notification;
			else
				msgs.add(notification);
		}
		return msgs;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void setTop(State newTop) {
		if (newTop != top) {
			NotificationChain msgs = null;
			if (top != null)
				msgs = ((InternalEObject) top).eInverseRemove(this, State_machinesPackage.STATE__STATE_MACHINE, State.class, msgs);
			if (newTop != null)
				msgs = ((InternalEObject) newTop).eInverseAdd(this, State_machinesPackage.STATE__STATE_MACHINE, State.class, msgs);
			msgs = basicSetTop(newTop, msgs);
			if (msgs != null)
				msgs.dispatch();
		} else if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, State_machinesPackage.STATE_MACHINE__TOP, newTop, newTop));
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getTransitions() {
		if (transitions == null) {
			transitions = new EObjectContainmentWithInverseEList(Transition.class, this, State_machinesPackage.STATE_MACHINE__TRANSITIONS, State_machinesPackage.TRANSITION__STATE_MACHINE);
		}
		return transitions;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getSubmachineState() {
		if (submachineState == null) {
			submachineState = new EObjectWithInverseResolvingEList(SubmachineState.class, this, State_machinesPackage.STATE_MACHINE__SUBMACHINE_STATE,
					State_machinesPackage.SUBMACHINE_STATE__SUBMACHINE);
		}
		return submachineState;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case State_machinesPackage.STATE_MACHINE__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.STATE_MACHINE__NAMESPACE, msgs);
			case State_machinesPackage.STATE_MACHINE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE, msgs);
			case State_machinesPackage.STATE_MACHINE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__CONTEXT:
				if (context != null)
					msgs = ((InternalEObject) context).eInverseRemove(this, CorePackage.MODEL_ELEMENT__BEHAVIOR, ModelElement.class, msgs);
				return basicSetContext((ModelElement) otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TOP:
				if (top != null)
					msgs = ((InternalEObject) top).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - State_machinesPackage.STATE_MACHINE__TOP, null, msgs);
				return basicSetTop((State) otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TRANSITIONS:
				return ((InternalEList) getTransitions()).basicAdd(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__SUBMACHINE_STATE:
				return ((InternalEList) getSubmachineState()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case State_machinesPackage.STATE_MACHINE__NAMESPACE:
				return eBasicSetContainer(null, State_machinesPackage.STATE_MACHINE__NAMESPACE, msgs);
			case State_machinesPackage.STATE_MACHINE__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE, msgs);
			case State_machinesPackage.STATE_MACHINE__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__CONTEXT:
				return basicSetContext(null, msgs);
			case State_machinesPackage.STATE_MACHINE__TOP:
				return basicSetTop(null, msgs);
			case State_machinesPackage.STATE_MACHINE__TRANSITIONS:
				return ((InternalEList) getTransitions()).basicRemove(otherEnd, msgs);
			case State_machinesPackage.STATE_MACHINE__SUBMACHINE_STATE:
				return ((InternalEList) getSubmachineState()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case State_machinesPackage.STATE_MACHINE__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE_MACHINE__NAME:
			return getName();
		case State_machinesPackage.STATE_MACHINE__VISIBILITY:
			return getVisibility();
		case State_machinesPackage.STATE_MACHINE__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case State_machinesPackage.STATE_MACHINE__NAMESPACE:
			return getNamespace();
		case State_machinesPackage.STATE_MACHINE__CLIENT_DEPENDENCY:
			return getClientDependency();
		case State_machinesPackage.STATE_MACHINE__CONSTRAINT:
			return getConstraint();
		case State_machinesPackage.STATE_MACHINE__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case State_machinesPackage.STATE_MACHINE__PRESENTATION:
			return getPresentation();
		case State_machinesPackage.STATE_MACHINE__TARGET_FLOW:
			return getTargetFlow();
		case State_machinesPackage.STATE_MACHINE__SOURCE_FLOW:
			return getSourceFlow();
		case State_machinesPackage.STATE_MACHINE__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case State_machinesPackage.STATE_MACHINE__COMMENT:
			return getComment();
		case State_machinesPackage.STATE_MACHINE__ELEMENT_RESIDENCE:
			return getElementResidence();
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case State_machinesPackage.STATE_MACHINE__STEREOTYPE:
			return getStereotype();
		case State_machinesPackage.STATE_MACHINE__TAGGED_VALUE:
			return getTaggedValue();
		case State_machinesPackage.STATE_MACHINE__REFERENCE_TAG:
			return getReferenceTag();
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case State_machinesPackage.STATE_MACHINE__BEHAVIOR:
			return getBehavior();
		case State_machinesPackage.STATE_MACHINE__CLASSIFIER_ROLE:
			return getClassifierRole();
		case State_machinesPackage.STATE_MACHINE__COLLABORATION:
			return getCollaboration();
		case State_machinesPackage.STATE_MACHINE__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case State_machinesPackage.STATE_MACHINE__PARTITION:
			return getPartition();
		case State_machinesPackage.STATE_MACHINE__ELEMENT_IMPORT:
			return getElementImport();
		case State_machinesPackage.STATE_MACHINE__CONTEXT:
			if (resolve)
				return getContext();
			return basicGetContext();
		case State_machinesPackage.STATE_MACHINE__TOP:
			return getTop();
		case State_machinesPackage.STATE_MACHINE__TRANSITIONS:
			return getTransitions();
		case State_machinesPackage.STATE_MACHINE__SUBMACHINE_STATE:
			return getSubmachineState();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE_MACHINE__NAME:
			setName((String) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case State_machinesPackage.STATE_MACHINE__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__CONTEXT:
			setContext((ModelElement) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__TOP:
			setTop((State) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__TRANSITIONS:
			getTransitions().clear();
			getTransitions().addAll((Collection) newValue);
			return;
		case State_machinesPackage.STATE_MACHINE__SUBMACHINE_STATE:
			getSubmachineState().clear();
			getSubmachineState().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE_MACHINE__NAME:
			setName(NAME_EDEFAULT);
			return;
		case State_machinesPackage.STATE_MACHINE__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case State_machinesPackage.STATE_MACHINE__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case State_machinesPackage.STATE_MACHINE__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case State_machinesPackage.STATE_MACHINE__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__CONSTRAINT:
			getConstraint().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__PRESENTATION:
			getPresentation().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__COMMENT:
			getComment().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case State_machinesPackage.STATE_MACHINE__STEREOTYPE:
			getStereotype().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__BEHAVIOR:
			getBehavior().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__COLLABORATION:
			getCollaboration().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__PARTITION:
			getPartition().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__CONTEXT:
			setContext((ModelElement) null);
			return;
		case State_machinesPackage.STATE_MACHINE__TOP:
			setTop((State) null);
			return;
		case State_machinesPackage.STATE_MACHINE__TRANSITIONS:
			getTransitions().clear();
			return;
		case State_machinesPackage.STATE_MACHINE__SUBMACHINE_STATE:
			getSubmachineState().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case State_machinesPackage.STATE_MACHINE__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case State_machinesPackage.STATE_MACHINE__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case State_machinesPackage.STATE_MACHINE__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case State_machinesPackage.STATE_MACHINE__NAMESPACE:
			return getNamespace() != null;
		case State_machinesPackage.STATE_MACHINE__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case State_machinesPackage.STATE_MACHINE__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case State_machinesPackage.STATE_MACHINE__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case State_machinesPackage.STATE_MACHINE__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case State_machinesPackage.STATE_MACHINE__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case State_machinesPackage.STATE_MACHINE__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case State_machinesPackage.STATE_MACHINE__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case State_machinesPackage.STATE_MACHINE__COMMENT:
			return comment != null && !comment.isEmpty();
		case State_machinesPackage.STATE_MACHINE__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case State_machinesPackage.STATE_MACHINE__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case State_machinesPackage.STATE_MACHINE__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case State_machinesPackage.STATE_MACHINE__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case State_machinesPackage.STATE_MACHINE__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case State_machinesPackage.STATE_MACHINE__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case State_machinesPackage.STATE_MACHINE__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case State_machinesPackage.STATE_MACHINE__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case State_machinesPackage.STATE_MACHINE__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case State_machinesPackage.STATE_MACHINE__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case State_machinesPackage.STATE_MACHINE__PARTITION:
			return partition != null && !partition.isEmpty();
		case State_machinesPackage.STATE_MACHINE__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case State_machinesPackage.STATE_MACHINE__CONTEXT:
			return context != null;
		case State_machinesPackage.STATE_MACHINE__TOP:
			return top != null;
		case State_machinesPackage.STATE_MACHINE__TRANSITIONS:
			return transitions != null && !transitions.isEmpty();
		case State_machinesPackage.STATE_MACHINE__SUBMACHINE_STATE:
			return submachineState != null && !submachineState.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // StateMachineImpl
